


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable INFO ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable Current_IP ""
    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable INFO ""

    variable AuditText ""
    variable Set_temp_High "35.0"	;# this is the temperature value above which they show as red not green

    proc Information {s} {
        variable INFO

        set INFO ""
        append INFO "MyWindow=window.open(\"\",\"MyWindow\",\"toolbar=no,menubar=no,status=no,scrollbars=yes\");"
        append INFO "MyWindow.document.write(\"<html><body>\");"
        append INFO "MyWindow.document.write(\"[string map {\" \\" \n <br>} $s]\\n\");"
        append INFO "MyWindow.document.write(\"</body></html>\");"
        append INFO "MyWindow.document.close();"
    }

   proc  show_variables {} {
        variable DigitizerList
        variable Digitizer
        variable FpgaList
        variable Fpga
        variable LogFlag
        variable LogCount

        InsertLog "Digitizers=$DigitizerList"
        InsertLog "Digitizer=$Digitizer; FpgaList=$FpgaList; Fpga=$Fpga"
        InsertLog "LogFlag=$LogFlag; LogCount=$LogCount"
   }

   proc do_auditALL {} {
        variable Digitizer
        variable DigitizerList
        variable AuditText

      set AuditText ""

       set DigitizerBAK $Digitizer

       foreach Digitizer $DigitizerList {do_audit}

       set Digitizer $DigitizerBAK

       set rc [catch {Information $AuditText} m]

   }

   proc do_auditCURRENT {} {
       variable AuditText

       set AuditText ""

       do_audit

       set rc [catch {Information $AuditText} m]

   }

   proc do_elog {} {
       variable AuditText

       Elog INFORMATION $AuditText
   }


    proc do_audit {} {
        variable Digitizer
        upvar #0 AGATADigitizerAccessServer_XportList XportList
        variable AuditText

         append AuditText "\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\n"

            set Address [first [split $XportList($Digitizer) :]]
            set rc1 [catch {exec ping -c 1 $Address} m1]
            set rc2 [catch {exec /usr/sbin/arp -a $Address} m2]
            if {$rc1 == 0 & $rc2 == 0} {
                append AuditText "\nDigitizer= $Digitizer; Address= $Address; Network info= $m2"
            } else {
                append AuditText "\nDigitizer= $Digitizer; Address= $Address"
                append AuditText "\nNetwork info= ping $m1; arp $m2"
            }
            do_probe
    }

proc do_probe {} {
    variable Digitizer
    variable AuditText

    set ShortTimeOut 5000 

    set CorePresent 0
    set SegmentPresent 0


    set fpga 3     ;# core main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes

    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]

    for {set tries 1} {$tries <= 2} {incr tries} {

#    append AuditText "\nprobing for Core Main Board"

    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
#        append AuditText "\nfound: Digitizer $Digitizer - Core: Main Board"
        set CorePresent 1
        break
    } else {
        append AuditText "\nError returned Probing for Core Main Board [first [split $m \n]]"
    }
    }

    if {$CorePresent == 1} {

#       append AuditText "\nprobing for Core ADCs"

       set fpga 2    ;# core ADCs
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
#              append AuditText "\nfound: Digitizer $Digitizer - Core: Virtex for core ADCs"
              set Addr 6
              set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $Addr A16} m]
              if {$rc == 0} {
                  append AuditText "\nCore......: Core ADC ......... fmw: [format "0x%x" $m]"
                  set rc [catch {do_readprom $fpga} m] ;# added this for Core ADC data
              } else {
                  append AuditText "\nDigitizer $Digitizer.$fpga: access error: $m"
              }
       } else {
           append AuditText "\nError returned Probing for Core: Core ADC [first [split $m \n]]"
       }

#       append AuditText "\nprobing for Core segment ADC card #1"

       set fpga 0    ;# core segment ADC card #1
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
#              append AuditText "\nfound: Digitizer $Digitizer - Core: Virtex for Segment ADC card 1"
              set Addr 15
              set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $Addr A16} m]
              if {$rc == 0} {
                  append AuditText "\nCore......: Segment ADC_1 fmw: [format "0x%x" $m]"
                  set rc [catch {do_readprom $fpga} m]
              } else {
                  append AuditText "\nDigitizer $Digitizer.$fpga: access error: $m"
              }
       } else {
           append AuditText "\nError returned Probing for Core: Segment ADC_1 [first [split $m \n]]"
       }

#       append AuditText "\nprobing for Core segment ADC card #2"

       set fpga 1    ;# core segment ADC card #2
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
#              append AuditText "\nfound: Digitizer $Digitizer - Core: Virtex for Segment ADC card 2"
              set Addr 15
              set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $Addr A16} m]
              if {$rc == 0} {
                  append AuditText "\nCore......: Segment ADC_2 fmw: [format "0x%x" $m]"
                  set rc [catch {do_readprom $fpga} m]
              } else {
                  append AuditText "\nDigitizer $Digitizer.$fpga: access error: $m"
              }
       } else {
           append AuditText "\nError returned Probing for Core: Segment ADC_2 [first [split $m \n]]"
       }
    }

#    append AuditText "\nprobing for Segment Main Board"

    set fpga 12    ;# segment main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
#        append AuditText "\nfound: Digitizer $Digitizer - Segment: Main Board"
        set SegmentPresent 1
    } else {
        append AuditText "\nError returned during Probe for Segment Main Board [first [split $m \n]]"
    }

    if {$SegmentPresent == 1} {

#       append AuditText "\nprobing for Segment ADC card #1"

       set fpga 8    ;# Segment ADC card #1
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
#           append AuditText "\nfound: Digitizer $Digitizer - Segment: Virtex for Segment ADC card 1"
              set Addr 15
              set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $Addr A16} m]
              if {$rc == 0} {
                  append AuditText "\nSegment: Segment ADC_1 fmw: [format "0x%x" $m]"
                  do_readprom $fpga
              } else {
                  append AuditText "\nDigitizer $Digitizer.$fpga: access error"
              }
       } else {
           append AuditText "\nError returned Probing for Segment: Segment ADC_1 [first [split $m \n]]"
       }

#       append AuditText "\nprobing for Segment ADC card #2"

       set fpga 9    ;# Segment ADC card #2
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
#              append AuditText "\nfound: Digitizer $Digitizer - Segment: Virtex for Segment ADC card 2"
              set Addr 15
              set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $Addr A16} m]
              if {$rc == 0} {
                  append AuditText "\nSegment: Segment ADC_2 fmw: [format "0x%x" $m]"
                  do_readprom $fpga
              } else {
                  append AuditText "\nDigitizer $Digitizer.$fpga: access error"
              }
       } else {
           append AuditText "\nError returned Probing for Segment: Segment ADC_2 [first [split $m \n]]"
       }

#       append AuditText "\nprobing for Segment ADC card #3"

       set fpga 10    ;# Segment ADC card #3
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
#              append AuditText "\nfound: Digitizer $Digitizer - Segment: Virtex for Segment ADC card 3"
              set Addr 15
              set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $Addr A16} m]
              if {$rc == 0} {
                  append AuditText "\nSegment: Segment ADC_3 fmw: [format "0x%x" $m]"
                  do_readprom $fpga
              } else {
                  append AuditText "\nDigitizer $Digitizer.$fpga: access error"
              }
       } else {
           append AuditText "\nError returned Probing for Segment: Segment ADC_3 [first [split $m \n]]"
       }

#       append AuditText "\nprobing for Segment ADC card #4"

       set fpga 11    ;# Segment ADC card #4
       set address 15
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
       set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $address A16} m]
       if {$rc == 0} {
#              append AuditText "\nfound: Digitizer $Digitizer - Segment: Virtex for Segment ADC card 4"
              set Addr 15
              set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $Addr A16} m]
              if {$rc == 0} {
                  append AuditText "\nSegment: Segment ADC_4 fmw: [format "0x%x" $m]"
                  do_readprom $fpga
              } else {
                  append AuditText "\nDigitizer $Digitizer.$fpga: access error"
              }
       } else {
           append AuditText "\nError returned Probing for Segment: Segment ADC_4 [first [split $m \n]]"
       }

   }

   set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer 0} m]   ;# reset timeout to default

   if {[expr $CorePresent + $SegmentPresent] == 0} {append AuditText "\nDigitizer not found"}

}


proc do_readprom {fpga} {
        variable AuditText

set Prom_control 0x880
set Prom_status 0x881
set Prom_base 0x800


#    append AuditText "\nReading PROM"

# check to see if it has read in correctly 

        set a [ ReadPromRegister $fpga $Prom_status ]
	if { $a != 4 } {
             append AuditText "\nProm has read back unsuccessfully. Status : $a"
             return
        }

	set a [ format "%c" [ ReadPromRegister $fpga 0x800 ] ]
	
	if { $a == "C" } {
		append AuditText " : Core ADC ..... "
	} elseif { $a == "S" } {
		append AuditText " : Segment ADC" 
	} else {
		append AuditText " : Not recognised -> Hex values =>"
                foreach entry { 0x800 0x801 0x802 0x803 0x804 0x805 0x806 0x807 } {
			set val [ ReadPromRegister $fpga $entry ]
			append AuditText " ,$val"
		}
		append AuditText " <----<--- !"
		return
	}
	set a [ ReadPromRegister $fpga 0x801 ]
	set b [ ReadPromRegister $fpga 0x802 ]
	set c [ ReadPromRegister $fpga 0x803 ]
	set d [ ReadPromRegister $fpga 0x804 ]
	set e [ ReadPromRegister $fpga 0x805 ]
	set f [ ReadPromRegister $fpga 0x806 ]
	set g [ ReadPromRegister $fpga 0x807 ]
	set serial [ format "%c%c%c%c" $d $c $b $a ]
	set revision [ format "%c" $e ]
	set mod_state [ format "%c%c" $g $f ]

	append AuditText " : Serial number => $serial"
	append AuditText " : Revision => $revision"
	append AuditText " : Mod state => $mod_state"

}

    proc ReadPromRegister {fpga Addr} {
        variable  Digitizer 
        global errorCode errorInfo
        variable AuditText

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $Addr A16} m]
 
        if {$rc != 0} {
            append AuditText "\nReadPromRegister: $Digitizer $fpga $Addr"
            append AuditText "\nReadPromRegister returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
   }

   proc do_temperature_auditALL {} {
        variable Digitizer
        variable DigitizerList
        variable AuditText
	variable Current_IP
	variable C
	variable S



      set AuditText ""

       set DigitizerBAK $Digitizer
	foreach item $DigitizerList {
		variable Current$item "-"
		variable Current_IP$item "0.0.0.0"
		variable Core_temperatures$item "-"
		variable Seg_temperatures$item "-"
	}

       foreach Digitizer $DigitizerList {
		do_temperature_audit
		set Current$Digitizer $Digitizer
		set Current_IP$Digitizer $Current_IP
		do_status_simple $Digitizer
	}

       set Digitizer $DigitizerBAK

#       set rc [catch {Information $AuditText} m]

   }

    proc do_temperature_audit {} {
        variable Digitizer
        upvar #0 AGATADigitizerAccessServer_XportList XportList
        variable AuditText
	variable Current_IP
	


            set Address [first [split $XportList($Digitizer) :]]
            set rc1 [catch {exec ping -c 1 $Address} m1]

            if {$rc1 == 0 } {
                append AuditText "\nDigitizer= $Digitizer; Address= $Address "
		set Current_IP "<font color=blue>$Address<\/font>"
		do_temperature_probe
            } else {
                append AuditText "\nDigitizer= $Digitizer; Address= $Address ???"
		set Current_IP "<font color=red><b>Not Found<\/b><\/font>"
            }
            
    }

proc do_temperature_probe {} {
    variable Digitizer
    variable AuditText
    variable Core_temperatures$Digitizer
    variable Seg_temperatures$Digitizer
    variable C
    variable S
    variable Set_temp_High

    set ShortTimeOut 5000 

    set CorePresent 0
    set SegmentPresent 0


    set fpga 3     ;# core main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes

    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
	set CorePresent 1
    } else {
#	append AuditText "\nError returned Probing for Core Main Board [first [split $m \n]]"
    }

    set fpga 12    ;# segment main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
        set SegmentPresent 1
    } else {
#        append AuditText "\nError returned during Probe for Segment Main Board [first [split $m \n]]"
    }

 
   set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer 0} m]   ;# reset timeout to default

   if {[expr $CorePresent + $SegmentPresent] == 0} {append AuditText "\nDigitizer not found"}
   if { $CorePresent == 1 } { 
	append AuditText " Core :" ; 
	audit_read_temperatures C
	set result ""
	for { set i 0 } { $i < 9 } { incr i } {
		if { $C($i) > $Set_temp_High } {
			set result [ concat $result "<font color=red>$C($i)<\/font>" ]
		} else {
			set result [ concat $result "<font color=green>$C($i)<\/font>" ]
		}
		set result [ concat $result "<font color=black>|<\/font>" ]
	}
	set Core_temperatures$Digitizer $result 
   }
   if { $SegmentPresent == 1 } {
	append AuditText " Segment :" 
	audit_read_temperatures S
	set result ""
	for { set i 0 } { $i < 10 } { incr i } {
		if { $S($i) > $Set_temp_High } {
			set result [ concat $result "<font color=red>$S($i)<\/font>" ]
		} else {
			set result [ concat $result "<font color=green>$S($i)<\/font>" ]
		}
		set result [ concat $result "<font color=black>|<\/font>" ]
	}
	set Seg_temperatures$Digitizer $result 
   }
}

   proc audit_read_temperatures {which}  {
   	variable AuditText
        variable Digitizer 
        variable Temps 
        variable C
        variable S 
        global errorCode errorInfo

        if {$which == "C"} {set fpga 3}   ;# select main board
        if {$which == "S"} {set fpga 12}   ;# select main board

        set Cmd 19       ;#   Use command 19 
        set Length 20    ;#   which returns 20 bytes of result

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $Cmd A16 $Length} m]
        if {$rc != 0} {
            InsertLog "Read temperatures returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            set Temps $m
            if {[llength $Temps] < 20} {
                InsertLog "Read temperatures returned with invalid response: $Temps"
                return -1
            }
        }

        for {set i 0; set j 0} {$i < 20} {incr i; incr j} {
           set msb [lindex $Temps $i]
           incr i
           set lsb [lindex $Temps $i]
           if {$fpga < 8} {
               set T [expr (((($msb * 255) + $lsb)/8) & 0x0fff) * 0.0625]
               if {$msb >= 128} then {
                  set C($j) [expr $T * -1.0]
               } else {
                  set C($j) $T
               }
	       set temp [ expr int( $C($j) ) ] 
               set C($j) [format "%-4.1f" $C($j)]
	       if { $temp == 0 } { set C($j) "00.0" }

	   } else {
               set T [expr (((($msb * 255) + $lsb)/8) & 0x0fff) * 0.0625]
               if {$msb >= 128} then {
                  set S($j) [expr $T * -1.0]
               } else {
                  set S($j) $T 
               }
	       set temp [ expr int( $S($j) ) ] 
               set S($j) [format "%-4.1f" $S($j)]
	       if { $temp == 0 } { set S($j) "00.0" }
	   }
        }
    }
   proc do_status_all {} {
        variable Digitizer
        variable DigitizerList
        variable AuditText
	variable Current_IP



      set AuditText ""

       set DigitizerBAK $Digitizer
	foreach item $DigitizerList {
		variable Current$item "-"
		variable Current_IP$item "0.0.0.0"

	}

       foreach Digitizer $DigitizerList {
		do_status_audit
	}

       set Digitizer $DigitizerBAK

       set rc [catch {Information $AuditText} m]
}

   proc do_status_current {} {
	variable AuditText

	set AuditText ""

	do_status_audit

       set rc [catch {Information $AuditText} m]
}


   proc do_status_simple { item } { ; # this needs the item number from the digitiser list
        variable Digitizer
 	variable Control_status$item
	
    set ShortTimeOut 5000 
    set Control_status$item "<font color=red>Fault<\/font>"

	set core_ok 1
	set seg_ok 1


    set fpga 3     ;# core main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes

    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
	scan [ lindex $m 0 ] "%x" result ;# fetch reg0
	if { [ expr $result & 0x1d ] != 0x1d } { set core_ok 0 }
	scan [ lindex $m 2 ] "%x" result ;# fetch reg2
	if { [ expr $result & 3 ] != 3 } { set core_ok 0 }
	scan [ lindex $m 3 ] "%x" result ;# fetch reg3
	if { [ expr $result & 0x77 ] != 0x77 } { set core_ok 0 }
	scan [ lindex $m 4 ] "%x" result ;# fetch reg4
	if { [ expr $result & 0x70 ] != 0x70 } { set core_ok 0 }
	scan [ lindex $m 5 ] "%x" result ;# fetch reg5
	if { [ expr $result & 0xc0 ] != 0xc0 } { set core_ok 0 }


    } else {
	set core_ok 0 
    }
    set fpga 12    ;# segment main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
	scan [ lindex $m 0 ] "%x" result ;# fetch reg0
	if { [ expr $result & 0x19 ] != 0x19 } { set seg_ok 0 }
	scan [ lindex $m 2 ] "%x" result ;# fetch reg2
	if { [ expr $result & 3 ] != 3 } { set seg_ok 0 }
	scan [ lindex $m 3 ] "%x" result ;# fetch reg4
	if { [ expr $result & 0xff ] != 0xff } { set seg_ok 0 }
	scan [ lindex $m 4 ] "%x" result ;# fetch reg5
	if { [ expr $result & 0xf0 ] != 0xf0 } { set seg_ok 0 }
	scan [ lindex $m 5 ] "%x" result ;# fetch reg6
	if { [ expr $result & 0x40 ] != 0x40 } { set seg_ok 0 }

    } else {
	set seg_ok 0 
    }

    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer 0} m]   ;# reset timeout to default

    if { [ expr $seg_ok & $core_ok ] == 1 } { set Control_status$item "<font color=green>OK<\/font>" }
}



   proc do_status_audit {} {
        variable Digitizer
        variable DigitizerList
        variable AuditText
	variable Current_IP
	
	append AuditText "\n---------------------------------------------------------------------------------\n"
	append AuditText "\n Digitiser number $Digitizer"
    set ShortTimeOut 5000 

    set CorePresent 0
    set SegmentPresent 0


    set fpga 3     ;# core main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes

    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
	set CorePresent 1
	append AuditText "\n Core returned :- $m ..... which means :-"
	append AuditText "\n Register 0  reports "
	scan [ lindex $m 0 ] "%x" result ;# fetch the first of the results
	if { [ expr $result & 1 ] == 1 } { append AuditText "\n... The Virtex clock is enabled" } else { append AuditText "\n... The Virtex clock is Not enabled" }
	if { [ expr $result & 2 ] == 2 } { append AuditText "\n... The Digitiser clock is internal" } else { append AuditText "\n... The Digitiser clock is from the Laser" }
	if { [ expr $result & 4 ] == 4 } { append AuditText "\n... Core psu status (high) OK" } else { append AuditText "\n... Core psu status (low) Fault !!!!!!!" }
	if { [ expr $result & 8 ] == 8 } { append AuditText "\n...  Segment psu status (high) OK" } else { append AuditText "\n... Segment psu status (low) Fault !!!!!!!" }
	if { [ expr $result & 0x10 ] == 0x10 } { append AuditText "\n...  Segment module present" } else { append AuditText "\n... NO Segment module present" }
	if { [ expr $result & 0x20 ] == 0x20 } { append AuditText "\n...  Segment module accessed seperately" } else { append AuditText "\n... Segment module access via Core module" }

	append AuditText "\n Register 2  reports "
	scan [ lindex $m 2 ] "%x" result ;# fetch the first of the results
	if { [ expr $result & 1 ] == 1 } { append AuditText "\n... config rdwr b pin is high" } else { append AuditText "\n... config rdwr b pin is high" }
	if { [ expr $result & 2 ] == 2 } { append AuditText "\n... The Spartan Done is High" } else { append AuditText "\n... The Spartan Done is Low" }


	append AuditText "\n Register 3  reports "
	scan [ lindex $m 3 ] "%x" result ;# fetch the first of the results
	if { [ expr $result & 1 ] == 1 } { append AuditText "\n... Segment 1 FPGA programmed OK" } else { append AuditText "\n... Segment 1 FPGA NOT programmed !!!!!!" }
	if { [ expr $result & 2 ] == 2 } { append AuditText "\n... Segment 2 FPGA programmed OK" } else { append AuditText "\n... Segment 2 FPGA NOT programmed !!!!!!" }
	if { [ expr $result & 4 ] == 4 } { append AuditText "\n... Core FPGA programmed OK" } else { append AuditText "\n... Core FPGA NOT programmed !!!!!!!" }

	append AuditText "\n Register 4  reports "
	scan [ lindex $m 4 ] "%x" result ;# fetch the first of the results
	if { [ expr $result & 1 ] == 1 } { append AuditText "\n... Segment 1 FPGA programming Unexpectedly Busy!!!!!!!" } else { append AuditText "\n... Segment 1 FPGA not Busy ( OK )" }
	if { [ expr $result & 2 ] == 2 } { append AuditText "\n... Segment 2 FPGA programming Unexpectedly Busy!!!!!!!" } else { append AuditText "\n... Segment 2 FPGA not Busy ( OK )" }
	if { [ expr $result & 4 ] == 4 } { append AuditText "\n... Core FPGA programming Unexpectedly Busy!!!!!!!" } else { append AuditText "\n... Core FPGA not Busy ( OK )" }
	if { [ expr $result & 0x10 ] == 0x10 } { append AuditText "\n... Segment 1 FPGA programming INIT true ( OK )" } else { append AuditText "\n... Segment 1 FPGA INIT Unexpectedly low!!!!!!!" }
	if { [ expr $result & 0x20 ] == 0x20 } { append AuditText "\n... Segment 2 FPGA programming INIT true ( OK )" } else { append AuditText "\n... Segment 2 FPGA INIT Unexpectedly low !!!!!!!" }
	if { [ expr $result & 0x40 ] == 0x40 } { append AuditText "\n... Core FPGA programming INIT true ( OK )" } else { append AuditText "\n... Core FPGA INIT Unexpectedly low!!!!!!!" }


	append AuditText "\n Register 5  reports "
	scan [ lindex $m 5 ] "%x" result ;# fetch the first of the results
	if { [ expr $result & 0x80 ] == 0x80 } { append AuditText "\n... Core module correctly identified" } else { append AuditText "\n... Segment module with Core Version of Spartan Code FAULT !!!!!!" }
	set result [ expr $result & 0x7F ]
	append AuditText "\n... Spartan FPGA code is version number $result"

    } else {
	append AuditText "\nError returned Probing for Core Main Board [first [split $m \n]]"
    }

    set fpga 12    ;# segment main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
        set SegmentPresent 1
	append AuditText "\n Segment returned :- $m ..... which means :-"
	append AuditText "\n Register 0  reports "
	scan [ lindex $m 0 ] "%x" result ;# fetch the first of the results
	if { [ expr $result & 1 ] == 1 } { append AuditText "\n... The Virtex clock is enabled" } else { append AuditText "\n... The Virtex clock is Not enabled" }
	if { [ expr $result & 8 ] == 8 } { append AuditText "\n...  Segment psu status (high) OK" } else { append AuditText "\n... Segment psu status (low) Fault !!!!!!!" }
	if { [ expr $result & 0x10 ] == 0x10 } { append AuditText "\n...  Core module present" } else { append AuditText "\n... NO Core module present" }
	if { [ expr $result & 0x20 ] == 0x20 } { append AuditText "\n...  Segment module accessed seperately" } else { append AuditText "\n... Segment module access via Core module" }

	append AuditText "\n Register 2  reports "
	scan [ lindex $m 2 ] "%x" result ;# fetch the first of the results
	if { [ expr $result & 1 ] == 1 } { append AuditText "\n... config rdwr b pin is high" } else { append AuditText "\n... config rdwr b pin is high" }
	if { [ expr $result & 2 ] == 2 } { append AuditText "\n... The Spartan Done is High" } else { append AuditText "\n... The Spartan Done is Low" }


	append AuditText "\n Register 3  reports "
	scan [ lindex $m 3 ] "%x" result ;# fetch the first of the results
	if { [ expr $result & 1 ] == 1 } { append AuditText "\n... Segment 1 FPGA programmed OK" } else { append AuditText "\n... Segment 1 FPGA NOT programmed !!!!!!" }
	if { [ expr $result & 2 ] == 2 } { append AuditText "\n... Segment 2 FPGA programmed OK" } else { append AuditText "\n... Segment 2 FPGA NOT programmed !!!!!!" }
	if { [ expr $result & 4 ] == 4 } { append AuditText "\n... Segment 3 FPGA programmed OK" } else { append AuditText "\n... Segment 3 FPGA NOT programmed !!!!!!!" }
	if { [ expr $result & 8 ] == 8 } { append AuditText "\n... Segment 4 FPGA programmed OK" } else { append AuditText "\n... Segment 4 FPGA NOT programmed !!!!!!!" }

	append AuditText "\n Register 4  reports "
	scan [ lindex $m 4 ] "%x" result ;# fetch the first of the results
	if { [ expr $result & 1 ] == 1 } { append AuditText "\n... Segment 1 FPGA programming Unexpectedly Busy!!!!!!!" } else { append AuditText "\n... Segment 1 FPGA not Busy ( OK )" }
	if { [ expr $result & 2 ] == 2 } { append AuditText "\n... Segment 2 FPGA programming Unexpectedly Busy!!!!!!!" } else { append AuditText "\n... Segment 2 FPGA not Busy ( OK )" }
	if { [ expr $result & 4 ] == 4 } { append AuditText "\n... Segment 3 FPGA programming Unexpectedly Busy!!!!!!!" } else { append AuditText "\n... Segment 3 FPGA not Busy ( OK )" }
	if { [ expr $result & 8 ] == 8 } { append AuditText "\n... Segment 4 FPGA programming Unexpectedly Busy!!!!!!!" } else { append AuditText "\n... Segment 4 FPGA not Busy ( OK )" }

	if { [ expr $result & 0x10 ] == 0x10 } { append AuditText "\n... Segment 1 FPGA programming INIT true ( OK )" } else { append AuditText "\n... Segment 1 FPGA INIT Unexpectedly low!!!!!!!" }
	if { [ expr $result & 0x20 ] == 0x20 } { append AuditText "\n... Segment 2 FPGA programming INIT true ( OK )" } else { append AuditText "\n... Segment 2 FPGA INIT Unexpectedly low!!!!!!!" }
	if { [ expr $result & 0x40 ] == 0x40 } { append AuditText "\n... Segment 3 FPGA programming INIT true ( OK )" } else { append AuditText "\n... Segment 3 FPGA INIT Unexpectedly low!!!!!!!" }
	if { [ expr $result & 0x80 ] == 0x80 } { append AuditText "\n... Segment 4 FPGA programming INIT true ( OK )" } else { append AuditText "\n... Segment 4 FPGA INIT Unexpectedly low!!!!!!!" }

	append AuditText "\n Register 5  reports "
	scan [ lindex $m 5 ] "%x" result ;# fetch the first of the results
	if { [ expr $result & 0x80 ] == 0x80 } { append AuditText "\n... Core module with Segment version of Spartan Code FAULT !!!!!!" } else { append AuditText "\n... Segment module correctly identified" }
	set result [ expr $result & 0x7F ]
	append AuditText "\n... Spartan FPGA code is version number $result"


    } else {
        append AuditText "\nError returned during Probe for Segment Main Board [first [split $m \n]]"
    }

 
   set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer 0} m]   ;# reset timeout to default


   }



# using the averaging code in the firmware to check the operationof the Analogue route....
# the controls are at 0x100. Readback values from 0x100 ,1,2,3,4,5 depending on number of channels per board.
# status is at 0x106. So to run write 1 to 0x100 then 0 , the check status is 0x660d at end of capture. read and store values in a list.
   proc do_anscan_all {} {
        variable Digitizer
        variable DigitizerList
        variable AuditText
	variable Current_an_IP
	variable AnReport 0


      set AuditText ""

       set DigitizerBAK $Digitizer
	foreach item $DigitizerList {
		variable Current_an$item "-"
		variable Current_an_IP$item "0.0.0.0"

	}

       foreach Digitizer $DigitizerList {
		do_anscan_current $Digitizer
	}

       set Digitizer $DigitizerBAK

}
   proc do_anscan {} {
        variable Digitizer
        variable DigitizerList
        variable AuditText
	variable Current_an_IP
	variable AnReport 1


      	set AuditText ""

       	set DigitizerBAK $Digitizer

	variable Current_an$Digitizer $Digitizer
	variable Current_an_IP$Digitizer "0.0.0.0"


	do_anscan_current $Digitizer

       	set Digitizer $DigitizerBAK
	set rc [catch {Information $AuditText} m]

}

   proc do_anscan_current { item } { ; # this needs the item number from the digitiser list
        variable Digitizer

	variable Core_results$item
	variable Seg_results$item

        upvar #0 AGATADigitizerAccessServer_XportList XportList

	variable Current_an_IP$item
	


            set Address [first [split $XportList($Digitizer) :]]
            set rc1 [catch {exec ping -c 1 $Address} m1]

            if {$rc1 == 0 } {
		set Current_an_IP$item "<font color=blue>$Address<\/font>"
            } else {
		set Current_an_IP$item "<font color=red><b>Not Found<\/b><\/font>"
            }
            


    set ShortTimeOut 5000 

    set bar "<font color=black>|<\/font>"

    set fpga 3     ;# core main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes

    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
  	set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer 0} m]   ;# reset timeout to default

	set core_results [ do_anscan_board $Digitizer C 2 ] ;# run the tests for the core of this module
	set seg1_results [ do_anscan_board $Digitizer C 0 ]
	set seg2_results [ do_anscan_board $Digitizer C 1 ] ;
	set Core_results$item [ concat $core_results $bar $seg1_results $bar $seg2_results ]
	} ; # scan the channels

    set fpga 12    ;# segment main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
 	set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer 0} m]   ;# reset timeout to default
	set seg1_results [ do_anscan_board $Digitizer S 0 ]
	set seg2_results [ do_anscan_board $Digitizer S 1 ]
	set seg3_results [ do_anscan_board $Digitizer S 2 ]
	set seg4_results [ do_anscan_board $Digitizer S 3 ]

	set Seg_results$item [ concat $seg1_results $bar $seg2_results $bar $seg3_results $bar $seg4_results ]	
    }
}

	proc do_anscan_board { Digi module board } {
 		variable AnReport
		variable Digitizer
		variable AuditText

		set dac_list { 0x8000 0 0x7fff }
		set limit_up { 2000 9000 16000 }
		set limit_down { 0 7000 14000 }
        	set pass 1
		set pass0 1 ;# assume all ok 
		set pass1 1 ;# assume all ok 
		if { $module == "C" & $board == 2 } {
			set fpga  $board 
            		set addr 7 ;#write the buffer enable
			set data 0x300
	 		set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
	 		if { $result != 0 } { 
				append AuditText "$module$board : No Core ADC board response\n" 
				return "----" 
			}
            		set addr 0x80 ;#write the ramp control to not running
			set data 0
	 		set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
			for { set i 0 } { $i < 3 } { incr i } { 
				set addr 0x81 ;#set the DAC
				set data [ lindex $dac_list $i ] ;

			        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
				set addr 0x82 ;#set the DAC
				set data [ lindex $dac_list $i ] ; 
                		set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]

				set addr 0x100 ;#reset the average unit
				set data 1 ; 
                		set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]

				set data 0 ; 
                		set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]

                		set addr 0x106
		 		set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16} m]
		 		if { $result != 0 } { return "F F" }
				append AuditText "Core pass number $i "
				if { $m == 0x660d } {
                    			set addr 0x100
			 		set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16} m]
			 		if { $result != 0 } { return "F F" }

					set high [ lindex $limit_up $i ]
					set low [ lindex $limit_down $i ]
					if { $m > $high | $m < $low } { set pass0 0 }
					append AuditText "0=>$m : $pass0 | " 

                    			set addr 0x101
			 		set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16} m]
			 		if { $result != 0 } { return "F F" }
					append AuditText "1=>$m : $pass1 \n"

					set high [ lindex $limit_up $i ]
					set low [ lindex $limit_down $i ]
					if { $m > $high | $m < $low } { set pass1 0 }
				} else { set pass 0 }	;# end of the if 0x660d
			} ;# end of the scan loop for the core

			set result ""
			for { set j 0 } { $j < 2 } { incr j } {
				if {[ set pass$j  ] == 1 } {
				    set result [ concat $result "<font color=green>P<\/font>" ]
				} else {
				    set result [ concat $result "<font color=red>F<\/font>" ]
				}
			}
			return $result            
		} else { ; # it should be a segment ADC
		    set pass 1
		    for { set j 0 } { $j < 6 } { incr j } {
		        set pass$j 1 ;# assume all ok 
		    }
		    if { $module == "C" } {
		        set fpga $board 
		    } else {
		        set fpga [ expr $board + 8 ]
		    }
		    set addr 7 ; # enable the buffers.
		    set data 0xff00 
		    set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
		    if { $result != 0 } { 
			append AuditText "$module$board : No Segment ADC board response\n" 
			return "-----------" 
		    }
	            for { set j 1 } { $j < 7 } { incr j } { ;# now enable all rocket I/O loopback
	                set addr [ expr 0x3 + ( $j << 4 )] ;
	                set data 0x40 ;# set the rocket i/o control to reset rocket I/O block
	                set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
	                set data 0 ;
	                set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
	                set data 1 ;# set the rocket i/o control to parallel loopback
	                set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
	            }
		    for { set i 0 } { $i < 3 } { incr i } { ;# the three different values for loop start
		        for { set j 0 } { $j < 6 } { incr j } {
		            set addr [ expr 0x81 + $j ] ;#set the DAC
		            set data [ lindex $dac_list $i ] ;
		            set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
		        }
		        for { set j 1 } { $j < 7 } { incr j } {
			        set addr [ expr 1 + (  $j << 4 ) ] ;# point to channel control register
				set data 0x8 ; #reset the min/max
				set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
				set data 0x4 ; #start the min/max
				set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
			}
			append AuditText "Segment $module:$board pass number $i : "
		        for { set j 0 } { $j < 6 } { incr j } { ;# read back and compare the results
				set base [ expr ( $j + 1 ) << 4  ]
			        set addr [ expr $base + 1 ] ;# point to channel control register
				set data 0x100	; # stop the min/max and point to the min register
				set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
				;# fetch the minimum
			        set addr [ expr 7 + $base ] ;# point to channel data register
		                set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16} m]
				set min $m
			        set addr [ expr 1 + $base ] ;# point to channel control register
				set data 0x110	; # stop the min/max and point to the max register
				set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $addr A16 1 $data} m]
				;# fetch the maximum
			        set addr [ expr 7 + $base ] ;# point to channel data register
		                set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16} m]
				set max $m
				set avg [ expr ( $max + $min ) / 2 ] ;#simple average
		                set high [ lindex $limit_up $i ]
		                set low [ lindex $limit_down $i ]
		                if { $avg > $high | $avg < $low } { set pass$j 0 } 
				append AuditText "$j=>$avg : [ set pass$j ] | "
		            }
			    append AuditText "\n"
		    } ; # end of the scan i for loop 
		    set result ""
		    if { $pass != 0 } {
		        for { set j 0 } { $j < 6 } { incr j } {
		            if { [ set pass$j ] == 1 } {
		                set result [ concat $result "<font color=green>P<\/font>" ]
		            } else {
		                set result [ concat $result "<font color=red>F<\/font>" ]
		            }
		        }
		        return $result 
		    } else {
		        return "F F F F F F" 
		    }
                   
        } ;# end of the if module = 

    } ;# end of proc

#################################################################################################################################
# read the SYNC register for each channel in the ADC cards, store them, wait a second, read them again, compare them 
# if the same => Green P, if different Red F.

   proc do_Syncscan_all {} {
        variable Digitizer
        variable DigitizerList
	variable Current_S_IP

       set DigitizerBAK $Digitizer
	foreach item $DigitizerList {
		variable Current_S$item "-"
		variable Current_S_IP$item "0.0.0.0"

	}

       foreach Digitizer $DigitizerList {
		do_Sync_scan_current $Digitizer
	}

       set Digitizer $DigitizerBAK

}
   proc do_Syncscan {} {
        variable Digitizer
        variable DigitizerList
	variable Current_S_IP
        variable AuditText ""

       	set DigitizerBAK $Digitizer

	variable Current_S$Digitizer $Digitizer
	variable Current_S_IP$Digitizer "0.0.0.0"

	do_Sync_scan_current $Digitizer

       	set Digitizer $DigitizerBAK
	set rc [catch {Information $AuditText} m]
}

  proc do_Sync_scan_current { item } { ; # this needs the item number from the digitiser list
        variable Digitizer
        variable AuditText
	variable SYNC_Core_results$item
	variable SYNC_Seg_results$item
	variable SYNC_Rx_OK 0;# set to 1 after the main SYNC status and counter check out ok.
        upvar #0 AGATADigitizerAccessServer_XportList XportList

	variable Current_S_IP$item
	


    set Address [first [split $XportList($Digitizer) :]]
    set rc1 [catch {exec ping -c 1 $Address} m1]

    if {$rc1 == 0 } {
	set Current_S_IP$item "<font color=blue>$Address<\/font>"
    } else {
	set Current_S_IP$item "<font color=red><b>Not Found<\/b><\/font>"
    }
            
    set ShortTimeOut 5000 

    set bar "<font color=black>|<\/font>"

    set fpga 3     ;# core main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes

    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
  	set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer 0} m]   ;# reset timeout to default

	set core_results [ do_Sync_scan_board $Digitizer C 2 ] ;# run the tests for the core of this module
	set seg1_results [ do_Sync_scan_board $Digitizer C 0 ]
	set seg2_results [ do_Sync_scan_board $Digitizer C 1 ] ;
	set SYNC_Core_results$item [ concat $core_results $bar $seg1_results $bar $seg2_results ]
	} ; # scan the channels

    set fpga 12    ;# segment main board
    set cmd 14     ;# safe read command for test
    set Length 6   ;# returns 6 bytes
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer  $ShortTimeOut} m]
    set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $cmd A16 $Length} m]
    if {$rc == 0} {
 	set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_SetTimeOut $Digitizer 0} m]   ;# reset timeout to default
	set seg1_results [ do_Sync_scan_board $Digitizer S 0 ]
	set seg2_results [ do_Sync_scan_board $Digitizer S 1 ]
	set seg3_results [ do_Sync_scan_board $Digitizer S 2 ]
	set seg4_results [ do_Sync_scan_board $Digitizer S 3 ]

	set SYNC_Seg_results$item [ concat $seg1_results $bar $seg2_results $bar $seg3_results $bar $seg4_results ]	
    }
}
	proc do_Sync_scan_board { Digi module board } {
		variable SYNC_Rx_OK ;# set to 1 after the main SYNC status and counter check out ok.
 		variable Sync_Report
		variable Digitizer
        	variable AuditText

		if { $module == "C" & $board == 2 } {
			set fpga  $board 
            		set addr 1 ;#read the Global sync status
	 		set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16 } m]
	 		if { $result != 0 } { 
				return "No Core Response" 
			}
			set Sync_Ok [ expr $m & 0x4 ]
            		set addr 0xB2 ;#First read of the error counter
	 		set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16 } m]
			set first $m
	 		set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16 } m]
			if { $Sync_Ok != 0 && $first == $m } {
				set SYNC_Rx_OK 1
			} else {
				return "SYNC pulse not Received Correctly by Core OPTO link "
			}
			foreach channel { 1 2 } {
				set addr [ expr ( $channel << 4 ) + 11 ]
	 			set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16 } m]
				set first_$channel $m
			}
			foreach channel { 1 2 } {
				set addr [ expr ( $channel << 4 ) + 11 ]
	 			set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16 } m]
				set second_$channel $m
			}


			set result ""
			append AuditText "Core Board :- "
			foreach channel { 1 2 } {
				append AuditText "| $channel :[set first_$channel ]:[set second_$channel  ]"
				if {[ set first_$channel  ] == [ set second_$channel  ] } {
				    set result [ concat $result "<font color=green>P<\/font>" ]
				} else {
				    set result [ concat $result "<font color=red>F<\/font>" ]
				}
			}
			append AuditText "\n" 
			return $result 
          
		} else { ; # it should be a segment ADC
			if { $SYNC_Rx_OK != 1 } {
				return ""
			}
			if { $module == "C" } {
				set fpga $board 
			} else {
				set fpga [ expr $board + 8 ]
			}
			foreach channel { 1 2 3 4 5 6 } {
				set addr [ expr ( $channel << 4 ) + 11 ]
	 			set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16 } m]
				if { $result != 0 } { set m -1 }
				set first_$channel $m
			}
			foreach channel { 1 2 3 4 5 6 } {
				set addr [ expr ( $channel << 4 ) + 11 ]
	 			set result [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $addr A16 } m]
				set second_$channel $m
			}

			append AuditText "Segment Board $board :- "
			set result ""
			foreach channel { 1 2 3 4 5 6 } {
				append AuditText " | $channel :[ set first_$channel  ] : [ set second_$channel  ] "
				if {[ set first_$channel  ] != -1 } {
					if {[ set first_$channel  ] == [ set second_$channel  ] } {
					    set result [ concat $result "<font color=green>P<\/font>" ]
					} else {
					    set result [ concat $result "<font color=red>F<\/font>" ]
					}
				} else { 
					set result [ concat $result "<font color=red>-<\/font>" ]
				}
			}
			append AuditText "\n"
			return $result        
                   
        } ;# end of the if module = 

    } ;# end of proc


#################################################################################################################################
   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag
       variable Digitizer

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {append AuditText "\ncgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {

           set w [first [lindex $cgidata 1]]
           set vl [second [lindex $cgidata 1]]

            switch -glob $w {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                DIGITIZER  {set Digitizer [second [lindex $cgidata 1]]}
                
                ANSCAN      {do_anscan }
                ANSCANALL   {do_anscan_all }

                SYNCSCAN      {do_Syncscan }
                SYNCSCANALL   {do_Syncscan_all }

                TSCAN      {do_temperatureCURRENT}
                TSCANALL   {do_temperature_auditALL}

		DGSTATALL  { do_status_all}
		DGSTAT     { do_status_current }

                AUDIT      {do_auditCURRENT}
                AUDITALL   {do_auditALL}
                AUDITELOG  {do_elog}

                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  ($w) ($vl) ($cgidata)"}
            }

            
         }
      }
   }   ;# end of do_click

   EnumerateDigitizers

	foreach item $DigitizerList {
		variable Current$item "-"
		variable Current_IP$item "0.0.0.0"
		variable Current_an$item "-"
		variable Current_an_IP$item "0.0.0.0"
		variable Current_S$item "-"
		variable Current_S_IP$item "0.0.0.0"
		variable Core_temperatures$item "-"
		variable Seg_temperatures$item "-"
		variable Control_status$item "-"
		variable Core_results$item "-"
		variable Seg_results$item "-"
		variable SYNC_Core_results$item "-"
		variable SYNC_Seg_results$item "-"
	}

}   ;# end of if {$started == 0} 

