




# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

    get_inspection     ;#  update values

}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable HelpTopic "Inspection"
   
    variable SignalL0
    variable SignalL1
    variable SignalD0
    variable SignalD1
    variable SignalA
    variable EnableA
    variable EnableD0
    variable EnableD1
    variable EnableL0
    variable EnableL1
    variable LogicInspectionList
    variable AnalogInspectionList
    variable DigitialInspectionList
    variable CoreLogicInspectionList
    variable CoreAnalogInspectionList
    variable CoreDigitialInspectionList
    variable SegmentLogicInspectionList
    variable SegmentAnalogInspectionList
    variable SegmentDigitialInspectionList

    set CoreLogicInspectionList { \
        "SYNC pulse" \
        "Front Panel SYNC pulse" \
        "High Gain Channel INH signal" \
        "Low Gain Channel INH signal" \
	"Internal Pulser signal" \
    }

    set CoreAnalogInspectionList { \
         undefined        \
         "Low Gain Pre-amp Channel"  \
    }

    set CoreDigitialInspectionList { \
         undefined        \
         "High Gain Channel"  \
         "Low Gain Channel"  \
         undefined        \
         undefined        \
         undefined        \
         undefined        \
         undefined        \
         "A_w_out signal from the trigger block"  \
         "cfd_signal from the trigger block"  \
    }

    set SegmentLogicInspectionList { \
        "SYNC from core board" \
        "SYNC-fp"  \
        "Inhibit A"  \
        "Inhibit B"   \
        "offset_optical_signal"  \
        "LED counter bit 1 = 25MHz" \
    }

    set SegmentAnalogInspectionList { \
         undefined        \
         "ADC Channel 1"  \
         "ADC Channel 2"  \
         "ADC Channel 3"  \
         "ADC Channel 4"  \
         "ADC Channel 5"  \
         "ADC Channel 6"  \
    }

    set SegmentDigitialInspectionList { \
         undefined        \
         "ADC Channel 1"  \
         "ADC Channel 2"  \
         "ADC Channel 3"  \
         "ADC Channel 4"  \
         "ADC Channel 5"  \
         "ADC Channel 6"  \
    }

    set SignalL0 0
    set SignalL1 0
    set SignalD0 0
    set SignalD1 0
    set SignalA 0

    set EnableA 0
    set EnableD0 0
    set EnableD1 0
    set EnableL0 1
    set EnableL1 1

   proc  show_variables {} {
      variable SignalL0
      variable SignalL1
      variable SignalD0
      variable SignalD1
      variable SignalA
      variable EnableA
      variable EnableD0
      variable EnableD1
      variable EnableL0
      variable EnableL1

      variable ::AGATADigitizer::Fpga

      InsertLog "SignalL0=$SignalL0; SignalL1=$SignalL1; SignalD0=$SignalD0; SignalD1=$SignalD1; SignalA=$SignalA"
      InsertLog "EnableL0=$EnableL0; EnableL1=$EnableL1; EnableD0=$EnableD0; EnableD1=$EnableD1; EnableA=$EnableA"
      InsertLog "Fpga=$Fpga"

   }


   proc get_inspection {} {
        variable ::AGATADigitizer::Fpga
        variable ::AGATADigitizer::FpgaIDs 
        variable SignalA
        variable SignalD0
        variable SignalD1
        variable SignalL0
        variable SignalL1
        variable EnableA
        variable EnableD0
        variable EnableD1

    set SignalL0 0
    set SignalL1 0
    set SignalD0 0
    set SignalD1 0
    set SignalA 0

    set EnableA 0
    set EnableD0 0
    set EnableD1 0
#    set EnableL0 0
#    set EnableL1 0

       if {$Fpga == "Digitizer not found"} {
          Alert "Return to main page and select valid digitizer"
          return
       }

       if {$Fpga == "Core: Main Board" || $Fpga == "Segment: Main Board"} {
          Alert "$Fpga does not have inspection lines"
          return               ;# Main boards have no registers
       }

       foreach i {2 3 8} {          ;# Analog & digitial inspection lines 
          set vl [get_inspection_register $i]
          if {$vl == -1} {break}
          switch $i {
             2  {set SignalD0 $vl}
             3  {set SignalD1 $vl}
             8  {set SignalA $vl}
          }
       }

       set vl [get_inspection_register 4]   ;# enables
       if {$vl != -1} {
           set EnableA  [expr ($vl >> 2) & 1]
           set EnableD0 [expr $vl & 1]
           set EnableD1 [expr ($vl >> 1) & 1]
       }

       if {$Fpga == "Core: Virtex for core ADCs"} {
	 	set vl [get_inspection_register 0x110]
          	if {$vl == -1} { return }
		set SignalL0 [ expr ($vl & 255 ) ]
		set SignalL1 [ expr (($vl >> 8 ) & 255 ) ]
		return
	}

       set vl [get_inspection_register 10]   ;# Logic inspection lines (for segment only)
       if {$vl != -1} {
           set SignalL0 [expr $vl & 255]
           set SignalL1 [expr ($vl >> 8) & 255]
       }
   }

   proc set_inspection {} {
        variable ::AGATADigitizer::Fpga
        variable ::AGATADigitizer::FpgaIDs 
        variable SignalA
        variable SignalD0
        variable SignalD1
        variable SignalL0
        variable SignalL1
        variable EnableA
        variable EnableD0
        variable EnableD1

       if {$Fpga == "Digitizer not found"} {
          Alert "Return to main page and select valid digitizer"
          return
       }

       if {$Fpga == "Core: Main Board" || $Fpga == "Segment: Main Board"} {
          Alert "$Fpga does not have inspection lines"
          return               ;# Main boards have no registers
       }

       set rc [set_inspection_register 2 $SignalD0]   ;#  inspection line source select
       set rc [set_inspection_register 3 $SignalD1]
       set rc [set_inspection_register 8 $SignalA]

       set rc [set_inspection_register 4 [expr $EnableD0 + ($EnableD1 << 1) + ($EnableA << 2)]]

       if {$Fpga == "Core: Virtex for core ADCs"} {
		set rc [set_inspection_register 0x110 [expr ($SignalL1 << 8) + $SignalL0]]
		return
	}

       set rc [set_inspection_register 10 [expr ($SignalL1 << 8) + $SignalL0]]
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {

           switch -glob [first [lindex $cgidata 1]] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                HELP     {do_help}

                ENABLEA  {variable EnableA;  set EnableA  [second [lindex $cgidata 1]]; set_inspection}
                ENABLED0 {variable EnableD0; set EnableD0 [second [lindex $cgidata 1]]; set_inspection}
                ENABLED1 {variable EnableD1; set EnableD1 [second [lindex $cgidata 1]]; set_inspection}
                ENABLEL0 {variable EnableL0; set EnableL0 [second [lindex $cgidata 1]]; set_inspection}
                ENABLEL1 {variable EnableL1; set EnableL1 [second [lindex $cgidata 1]]; set_inspection}

                DISABLE  {
                    variable EnableA; set EnableA 0
                    variable EnableD0; set EnableD0 0
                    variable EnableD1; set EnableD1 0
                    set_inspection
                }

                SIGNALA   {variable SignalA;   set SignalA   [second [lindex $cgidata 1]]; set_inspection}
                SIGNALD0  {variable SignalD0;  set SignalD0  [second [lindex $cgidata 1]]; set_inspection}
                SIGNALD1  {variable SignalD1;  set SignalD1  [second [lindex $cgidata 1]]; set_inspection}
                SIGNALL0  {variable SignalL0;  set SignalL0  [second [lindex $cgidata 1]]; set_inspection}
                SIGNALL1  {variable SignalL1;  set SignalL1  [second [lindex $cgidata 1]]; set_inspection}

                MainLog {}
                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }
    get_inspection

}  ;# end of if {$started == 0}



