
#    Note:  This is loaded into the namespace  AIDA_SaveRestore

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

     do_DBUpdate
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable DBNameList {"xxx"}

   variable index 0
   variable selected -1


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable selected
        global MIDAS_DataAcquisitionControlServer_Exists
        global DataAcquisitionControlServerHost
        variable AcqSetOption

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "selected=$selected"
        InsertLog "DBPath = $::AIDA::DBRootName/$::AIDA::DBNodeBase/$::AIDA::DBNodeName"

        foreach fee64 $::AIDA::ModuleMenu {InsertLog "$fee64"}

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
         InsertLog "MIDAS_DataAcquisitionControlServer_Exists = $MIDAS_DataAcquisitionControlServer_Exists"
       }

       if {[info exists DataAcquisitionControlServerHost]} then {
         InsertLog "DataAcquisitionControlServerHost = $DataAcquisitionControlServerHost"
       }

        InsertLog "ACQSERVER: $::DataAcquisition::ACQSERVER"
        InsertLog "AcqOption: $AcqSetOption"

#        InsertLog "HasBeenConfigured = [ReadRegister HasBeenConfigured]"
#        InsertLog "HasBeenRestored = [ReadRegister HasBeenRestored]"

   }

      proc Selection {} {
          variable selected

          set selected 0

           set i 1
           foreach item $::AIDA::ModuleMenu {
               set selected [expr $selected | (1 << $i)]
               incr i
           }
      }

      proc do_Select {i} {
         variable selected

         set selected [expr $selected | (1 << $i)]
      }

      proc do_UnSelect {i} {
         variable selected

         set selected [expr $selected & ~(1 << $i)]
      }


    proc do_setopt {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        variable AcqSetOption
        global MIDAS_DataAcquisitionControlServer_Exists

        set AcqSetOption $option

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {

          set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer DoOption "$AcqSetOption"} m]
       } else {

           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoOption "$AcqSetOption"} m]
      }

        if {$rc != 0} {
            InsertLog "DO OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "DO OPTION returned $m ([format "0x%x" $m])"
        }

     }

      proc do_Save {} {
        variable selected
        global env

         if {$selected == 0} {Selection}
      
        InsertLog "Saving FEE64 settings to $::AIDA::DBRootName/$::AIDA::DBNodeBase"

         set BAK $::AIDA::FEE64   ;# save

           set i 0
           foreach fee64 $::AIDA::ModuleMenu {
             incr i
             if {[expr ($selected >> $i) & 1] == 0} {continue}

             set ::DataAcquisition::ACQSERVER $fee64

	     set fname [file join $env(MIDASBASE) XilinxLinux ppc_4xx rfs $fee64 tmp SaveState.log]
             set z [catch {unlink $fname} fid]

             do_setopt "ParameterSave=$::AIDA::DBNodeBase"

             InsertLog "FEE64 settings being saved for $::DataAcquisition::ACQSERVER"
          }

         set ::AIDA::FEE64 $BAK    ;# restore

#        InsertLog "FEE64 settings saved to $::AIDA::DBRootName/$::AIDA::DBNodeBase"

#        Elog INFORMATION "FEE64 settings saved to $::AIDA::DBRootName/$::AIDA::DBNodeBase"

        do_DBUpdate
    }

      proc do_Restore {} {
        variable selected
        global env

         if {$selected == 0} {Selection}
      
        InsertLog "Restoring FEE64 settings from $::AIDA::DBRootName/$::AIDA::DBNodeBase"

         set BAK $::AIDA::FEE64   ;# save
        
          set i 0
          foreach fee64 $::AIDA::ModuleMenu {
             incr i
             if {[expr ($selected >> $i) & 1] == 0} {continue}

             set ::DataAcquisition::ACQSERVER $fee64

             set fname [file join $env(MIDASBASE) XilinxLinux ppc_4xx rfs $fee64 tmp RestoreState.log]
             set z [catch {unlink $fname} fid]

             do_setopt "ParameterRestore=$::AIDA::DBNodeBase"
 
             InsertLog "FEE64 settings being restored for $::DataAcquisition::ACQSERVER"
          }

         set ::AIDA::FEE64 $BAK    ;# restore

#        InsertLog "FEE64 settings restored from $::AIDA::DBRootName/$::AIDA::DBNodeBase"

#       ::AIDA::WriteRegister HasBeenRestored 1

#        Elog INFORMATION "FEE64 settings restored from $::AIDA::DBRootName/$::AIDA::DBNodeBase"

       do_DBUpdate
    }


     proc do_SaveState {} {
        global env
        variable selected

        InsertLog "FEE64 settings Save status [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

         set BAK $::AIDA::FEE64   ;# save

           set i 0
           foreach fee64 $::AIDA::ModuleMenu {
             incr i
             if {[expr ($selected >> $i) & 1] == 0} {continue}

                InsertLog "$fee64"

		set fname [file join $env(MIDASBASE) XilinxLinux ppc_4xx rfs $fee64 tmp SaveState.log]
         	set z [catch {open $fname r} fid]
                if {$z != 0} {InsertLog "log access error: $fid"} else {
		  set contents [ read $fid ]
		  InsertLog "$contents"
                  close $fid
                }
           }

        set ::AIDA::FEE64 $BAK    ;# restore

     }

     proc do_RestoreState {} {
        global env
        variable selected

        InsertLog "FEE64 settings Restore status [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

         set BAK $::AIDA::FEE64   ;# save

           set i 0
           foreach fee64 $::AIDA::ModuleMenu {
             incr i
             if {[expr ($selected >> $i) & 1] == 0} {continue}

                InsertLog "$fee64"

		set fname [file join $env(MIDASBASE) XilinxLinux ppc_4xx rfs $fee64 tmp RestoreState.log]
         	set z [catch {open $fname r} fid]
                if {$z != 0} {InsertLog "log access error: $fid"} else {
		  set contents [ read $fid ]
		  InsertLog "$contents"
                  close $fid
                }
           }

        set ::AIDA::FEE64 $BAK    ;# restore

     }

      proc do_DBName {vl} {
         global Options

          set ::AIDA::DBNodeBase $vl
          DBCreateNode $::AIDA::DBRootName/$::AIDA::DBNodeBase

          set Options(ASIC.settings) $vl
          SaveOptions

          InsertLog "Data Base node $::AIDA::DBRootName/$::AIDA::DBNodeBase contains [DBGetNodes $::AIDA::DBRootName/$::AIDA::DBNodeBase *]"
      }

      proc do_DBUpdate {} {
          variable DBNameList

          set DBNameList {}
          foreach item [DBGetNodes $::AIDA::DBRootName *] {
              if {$item == "Options"} continue
              lappend DBNameList $item
          }
      }
    

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

      if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           set w [lindex $cgidata 1]

           switch -glob [lindex $w 0] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                RELOAD   {variable selected; if {$selected == 0} {Selection}}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                LOGON    {set LogFlag 1}
                LOGOFF   {set LogFlag 0}

                DBNAMES -
                DBNAME   {do_DBName [lindex $w 1]}

                GENKEY   {do_DBName [date +%Y%h%d-%H.%M.%S]}

                RESTORE      {do_Restore}
                RESTORESTATE {do_RestoreState}
                SAVE         {do_Save}
                SAVESTATE    {do_SaveState}
      
                SELECT    {do_Select [lindex $w 1]}
                UNSELECT  {do_UnSelect [lindex $w 1]}

                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

     Selection

     do_DBUpdate
     LoadOptions

     set html ""


}  ;# end of if {$started == 0}

