## setup the ADCs assuming they are set to produce test patterns
set Cal_Base 0x800
set Cal_Control 0 
set Cal_Status 3
set Cal_BitAlign 2
set Cal_WordAlign 4
    variable ADCList {0 1 2 3 4 5 6 7}

	      InsertLog "FEE64 = $::AIDA::FEE64"
          foreach adc $ADCList {
        
              WriteAD9252Register $adc 0x0d 0x48 ; # set for calibrate pattern
              WriteAD9252Register $adc 0xff 1   ;# device update
	      set val [ReadAD9252Register $adc 0xd ]
		if { $val == 0x48 } {
			InsertLog "Pattern selected for ADC $adc ok"
		} else {
			InsertLog "Pattern select failed for ADC $adc. Got $val not 0x48"
		}
          }
	after 20 ;# try and see if a slow here helps
	WriteAIDARegister [ expr $Cal_Base + $Cal_Control ] 0
	set val [ ReadAIDARegister [ expr $Cal_Base + $Cal_Status ] ] 
	InsertLog " Status #1 : $val "
	WriteAIDARegister [ expr $Cal_Base + $Cal_Control ] 8
	set val [ ReadAIDARegister [ expr $Cal_Base + $Cal_Status ] ] 
	InsertLog " Status #2 : $val "
	WriteAIDARegister [ expr $Cal_Base + $Cal_Control ] 9
	after 20 ; # here too
	set val [ ReadAIDARegister [ expr $Cal_Base + $Cal_BitAlign ] ] 
	InsertLog " Bit Align result : $val "
	set val [ ReadAIDARegister [ expr $Cal_Base + $Cal_WordAlign ] ] 
	InsertLog " Word Align result : $val "
	set val [ ReadAIDARegister [ expr $Cal_Base + $Cal_Status ] ] 
	if { $val == 0xf7 } {
		InsertLog "ADCs Calibrated. " 
	} else {
		InsertLog "Warning : Status is : $val not 0xF7 "
		InsertLog " ADCs NOT Calibrated. Check they are set for Calibrate pattern"
	}
          foreach adc $ADCList {
       
           WriteAD9252Register $adc 0x0d 0 ; # set for data output
           WriteAD9252Register $adc 0xff 1   ;# device update
      }
	InsertLog "ADCs Set for data transmission. " 

