

# variable started 0


if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable allservers 0
    variable SelectedItem 1
    variable AutoUpdate 0

    variable JS ""

    variable NUM 64
    for {set i 0} {$i <= $NUM} {incr i} {
      if {![info exists ITEM($i)]} {set ITEM($i) ""}
    }

#    set f [file join $env(MIDASBASE) TclHttpd Html CAEN RunControl stats.defn.tcl]
#    set z [catch {source $f} m]

    proc do_counters {} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists
	
	if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetCounters} m]
           set counters $m
       } else {
           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
	       set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
	       DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__GetCounters} m]
           set counters [second $m]
           if {[first $counters] == 0x10004} \
	       {InsertLog "Error reading counters [first $counters]"; set counters ""}
       }
	
        set msg ""
        if {$rc != 0} {
            InsertLog "COUNTERS returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            foreach item $counters {append msg "[expr $item] "}
        }
 	return $msg
    }
    
    proc do_rates {} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists
	
	if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetRates} m]
           set rates $m
       } else {
           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__GetRates} m]
           set rates [second $m]
           if {[first $rates] == 0x10004} \
                {InsertLog "Error reading rates [first $rates]"; set rates ""}
       }

        set msg ""
        if {$rc != 0} {
            InsertLog "RATES returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            foreach item $rates {append msg "[expr $item] "}
	}
	
	return $msg
	
    }

    proc do_setopt {option} {
        global errorCode errorInfo
        global DataAcquisitionControlServerHost
        global MIDAS_DataAcquisitionControlServer_Exists
        variable AcqSetOption
        variable allservers

     set AcqSetOption $option

      set BAK $::DataAcquisition::ACQSERVER

      foreach acqserver $::DataAcquisition::ACQSERVERS {
          if {$allservers == 0 && $acqserver != $::DataAcquisition::ACQSERVER} continue

          set ::DataAcquisition::ACQSERVER $acqserver

       if {[info exists MIDAS_DataAcquisitionControlServer_Exists]} then {
           set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoOption "$AcqSetOption"} m]
       } else {
           if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
                set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
                DataAcquisitionControlClient_Configure
           }
           set rc [catch {DataAcquisitionControlClient__DoOption "$AcqSetOption"} m]
       }

        if {$rc != 0} {
            InsertLog "DO OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "DO OPTION returned $m ([format "0x%x" $m])"
#            InsertLog "DO OPTION returned $m"
        }

      }

      set ::DataAcquisition::ACQSERVER $BAK

    }

    proc do_zero {} {do_setopt ClearStats}

   proc  show_variables {} {
       variable allservers
       variable AutoUpdate
       variable SelectedItem
       variable NUM

       InsertLog "allservers=$allservers; autoupdate=$AutoUpdate; selecteditem=$SelectedItem"
       InsertLog "Num=$NUM"
   }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   DOCOUNTERS {do_counters}
                   DORATES    {do_rates}

                   UPDATESTATS -
                   UPDATE    {}
		   
                   AUTOUPDATE  {variable AutoUpdate; set AutoUpdate [expr ($AutoUpdate + 1) & 1]}
		   
                   DOZERO    {do_zero}

                   COUNTER   {variable SelectedItem; set SelectedItem $vl}

                   SERVER     {set ::DataAcquisition::ACQSERVER $vl}
                   ALLSERVERS {variable allservers; set allservers [expr ($allservers + 1) & 1]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
       }

    }  ;#  end of do_click

}   ;# end of if {$started == 0}




