
#    Note:  This is loaded into the namespace  MERGE

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable NRows 4
    variable NCols 16
    variable NLinks [expr $NRows * $NCols]
    variable LinkInUse
    for {set i 0} {$i < $NLinks} {incr i} {set LinkInUse($i) 0}
    variable LinkAlive
    for {set i 0} {$i < $NLinks} {incr i} {set LinkAlive($i) 0}
    variable LinkColour
    for {set i 0} {$i < $NLinks} {incr i} {set LinkColour($i) white}
    variable LinksAvailable 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

   proc  show_variables {} {

       make-UIregisters
       InsertLog "Merge State = [DataAcqState]"
       InsertLog "Merge Pause State = [ReadNetVar NetVar.DACQ.Spaused]"
       InsertLog "Merge Xfer State = [ReadNetVar NetVar.DACQ.Ctxenable]"

       InsertLog "LinksAvailable = [ReadNetVar NetVar.Merge.LinksAvailable]"
       InsertLog "LinksAlive = [ReadNetVar NetVar.Merge.Links.Alive]"
       InsertLog "LinksInUse = [ReadNetVar NetVar.Merge.Links.InUse]"

   }

   proc doState {} {
       variable NLinks
       variable LinksAvailable
       variable LinkInUse
       variable LinkAlive
       variable LinkColour

      UpdateMergeLinks

      InsertLog "LinksAvailable: $LinksAvailable"

       set txt ""
       for {set link 0} {$link < $NLinks} {incr link} {
           if {$link < $LinksAvailable} then {
              if {$LinkInUse($link) == 1} then {
                  append txt "$link "
              }
           }
       }
       InsertLog "LinksInUse: $txt"

       set txt ""
       for {set link 0} {$link < $NLinks} {incr link} {
           if {$link < $LinksAvailable} then {
              if {$LinkAlive($link) != 0} then {
                  append txt "$link "
              }
           }
       }
       InsertLog "LinksAlive: $txt"

       for {set link 0} {$link < $NLinks} {incr link} {
           if {$link < $LinksAvailable} then {
              if {$LinkInUse($link) == 1 && $LinkAlive($link) == 0} then {
                  InsertLog "Warning: Link $link is in use but is NOT alive"
              }
           }
       }

   }

   proc doLink {i} {
      variable LinkInUse

      set Use [ReadNetVar NetVar.Merge.Link$i.InUse]
      set LinkInUse($i) [expr ($Use + 1) & 1]

      WriteNetVar NetVar.Merge.Link$i.InUse $LinkInUse($i)

      store_MergeLinks

   }

   proc doZeroStats {}  {

     DataAcqCommand 7 "Clear Statistics" 0 2

   }

   proc doZeroTimeStamp {} {

      WriteNetVar NetVar.DACQ.InitialTimeStamp 0
   }

   proc doRestart {args} {

      DataAcqCommand 18 "MergeRestart" 0 2

      UpdateMergeLinks
   }

   proc UpdateMergeLinks {} {
       variable NLinks
       variable LinksAvailable
       variable LinkInUse
       variable LinkAlive
       variable LinkColour

       set LinksAvailable  [ReadNetVar NetVar.Merge.LinksAvailable]
       set LinksAlive  [ReadNetVar NetVar.Merge.Links.Alive]
       set LinksInUse  [ReadNetVar NetVar.Merge.Links.InUse]

       for {set link 0} {$link < $NLinks} {incr link} {
           set LinkInUse($link) [lindex $LinksInUse $link]
           set LinkAlive($link) [lindex $LinksAlive $link]
       }

       for {set link 0} {$link < $NLinks} {incr link} {
           if {$link < $LinksAvailable} then {
              if {[lindex $LinksInUse $link] == 0} then {
                 if {[lindex $LinksAlive $link] == 0} {
                     set LinkColour($link) red
                 } else {
                     set LinkColour($link) DarkGoldenRod
                 }
              } else {
                 if {[lindex $LinksAlive $link] == 0} {
                     set LinkColour($link) DarkOliveGreen
                 } else {
                     set LinkColour($link) LimeGreen
                 }
              }
           } else {
              if {[lindex $LinksInUse $link] == 0} then {
                     set LinkColour($link) grey
              } else {
                     set LinkColour($link) black
              }
           }
       }
  }

  proc PageNotes {} {InsertLog "Notes in preparation"}

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   NOTES    {PageNotes}

                   GO     {doGo}
                   STOP   {doStop}
                   SETUP  {doSetUp}
                   PAUSE  {doPause}
                   RESTART {doRestart}
                   XFER   {doXfer}

                   STATE  {doState}
                   ZERO   {doZeroTimeStamp}

                   LINKS  {doLink $vl}

                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }

        UpdateMergeLinks
     }

    catch {UpdateMergeLinks}

}   ;# end of if {$started == 0}




