
#    Note:  This is loaded into the namespace  PGRIS_Diagnostics

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

global MIDAS_XPGRISAccessServer_Verbose
set MIDAS_XPGRISAccessServer_Verbose 0


   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable AddrSpaceList

    variable Offset0x00000
    variable Offset0x10000
    variable Offset0x20000

    variable AddrSpace
    variable Address
    variable Offset
    variable SData
    variable GData

     set AddrSpaceList [list \
         "Event Readout : area 0: 0x00000" \
         "Peripheral    : area 1: 0x10000" \
         "MBD: I2C      : area 2: 0x20000" \
    ]

    set Offset0x00000 [list \
        "Control:  0x00"  \
        "Status:  0x01"  \
        ":  0x02"  \
        "Monitor :  0x03"  \
        "Block Low Count:  0x04"   \
        "Block High Count:  0x05"  \
        ":  0x06"   \
        "High Water Mark:  0x07"  \
        ":  0x08"  \
        ":  0x09"  \
        "Version String:  0x0a"  \
    ]

    set Offset0x10000 [list \
        "Local Control:  0x00"  \
        "Local Status :  0x01"  \
        "HV enables:  0x02"  \
        "Peripheral version:  0x03"  \
        ":  0x04"   \
        ":  0x05"  \
        ":  0x06"   \
        ":  0x07"  \
        ":  0x08"  \
        ":  0x09"  \
        ":  0x0a"  \
    ]

    set Offset0x20000 [list \
        "ASIC reg0 :  0x00"  \
        "ASIC reg1:  0x01"  \
        ":  0x02"  \
        ":  0x03"  \
        "DAC A:  0x04"   \
        "DAC B:  0x05"  \
        "DAC C:  0x06"   \
        "DAC D:  0x07"  \
        "Control:  0x08"  \
        "Status:  0x09"  \
        "Read register:  0x0a"  \
	"Detector : 0x0b" \
    ]

    set Address 0x0000
    set AddrSpace [lindex $AddrSpaceList 0]
    set Offset 0
    set SData            0x0000
    set GData            ******

   proc  show_variables {} {
        variable AddrSpace
        variable Address
        variable Offset
        variable SData
        variable GData

        InsertLog "AddrSpace=$AddrSpace; Address=$Address; Offset=$Offset; SetData=$SData; GetData=$GData"
   }

   proc RunTest {i} {

       set rc [catch {source [file join Tests $i.tcl]} m]
       InsertLog "Test $i returned rc=$rc and message\n $m"
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag
       variable Address
       variable AddrSpace
       variable Offset
       variable SData
       variable GData

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgDiagnostics.tmlidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

            switch -glob $w {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                SET      {WritePGRISRegister [expr $Address + $Offset] $SData}
                GET      {set GData [ReadPGRISRegister [expr $Address + $Offset]]}
                SETGET   {
                    WritePGRISRegister [expr $Address + $Offset] $SData
                    set GData [ReadPGRISRegister [expr $Address + $Offset]]
                }

                ADDRSPACE  {
                    set Address [last [lindex $cgidata 1]]
                    set AddrSpace "[lreplace [lindex $cgidata 1] 0 0]"
                    set Offset 0

                }
                OFFSET     {set Offset [last [lindex $cgidata 1]]}
                SDATA      {set SData  [last [lindex $cgidata 1]]}

                EXPERT   {$vl [third [lindex $cgidata 1]]}

                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

}   ;# end of if {$started == 0} 

