
#    Note:  This is loaded into the namespace  OPTION

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

     do_click

#     LoadOptions
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable ::DataAcquisition::PROJECT
    variable PROJECT $::DataAcquisition::PROJECT
    variable OptionSet "Global"


   proc SaveOptions {} {
      variable PROJECT
      variable OptionSet

      set NodeBase [set ::[set PROJECT]::DBNodeBase]
      set ::[set PROJECT]::DBNodeBase "Options"

      set NodeName [set ::[set PROJECT]::DBNodeName]
      set ::[set PROJECT]::DBNodeName $OptionSet

      set OptionList ""
      foreach item [lsort [array names ::Options]] {
         if {$item == "Index"} {continue}
         if {[string length $OptionList] > 0} {append OptionList "&&"}
         append OptionList "$item"
         DBSetValue "$item" [first [set ::Options($item)]]
      }
      DBSetValue Index $OptionList

      set ::[set PROJECT]::DBNodeBase $NodeBase
      set ::[set PROJECT]::DBNodeName $NodeName
   }

   proc LoadOptions {} {
      variable PROJECT
      variable OptionSet

      set NodeBase [set ::[set PROJECT]::DBNodeBase]
      set ::[set PROJECT]::DBNodeBase "Options"

      set NodeName [set ::[set PROJECT]::DBNodeName]
      set ::[set PROJECT]::DBNodeName $OptionSet

      catch {unset ::Options}

      foreach item [split [DBGetValue Index] &&] {
         if {$item == ""} {continue}
         if {$item == "Index"} {continue}
         if {$item == "Error!"} {continue}
         set vl [DBGetValue $item]
         if {$vl != "Error!"} {set ::Options($item) $vl}
      }

      set ::[set PROJECT]::DBNodeBase $NodeBase
      set ::[set PROJECT]::DBNodeName $NodeName
   }


   proc  show_variables {} {
       variable PROJECT
       variable OptionSet

       set rc [catch {LoadOptions} m]
       if {$rc != 0} {"LoadOptions returns: $m"}

      set NodeBase [set ::[set PROJECT]::DBNodeBase]
      set ::[set PROJECT]::DBNodeBase "Options"

      set NodeName [set ::[set PROJECT]::DBNodeName]
      set ::[set PROJECT]::DBNodeName $OptionSet

       InsertLog "Set = $OptionSet"

       InsertLog "Project $PROJECT"
       InsertLog "DBRootName [set ::[set PROJECT]::DBRootName]"
       InsertLog "DBNodeBase [set ::[set PROJECT]::DBNodeBase]"
       InsertLog "DBNodeName [set ::[set PROJECT]::DBNodeName]"

       InsertLog "Options: [lsort [array names ::Options]]"

      set ::[set PROJECT]::DBNodeBase $NodeBase
      set ::[set PROJECT]::DBNodeName $NodeName

   }

   proc do_redisplay {} {}

   proc do_setOpt {index vl} {

    set i 0
    foreach item [lsort [array names ::Options]] {
       if {$i == "$index"} {set ::Options($item) $vl; break}
       incr i
    }

       SaveOptions
   }

   proc do_newOpt {item} {

       set ::Options($item) "undefined"

       SaveOptions
   }

   proc do_delOpt {index} {

    set i 0
    foreach item [lsort [array names ::Options]] {
       if {$i == "$index"} {unset ::Options($item); break}
       incr i
    }

       SaveOptions
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   OPTS     {do_setOpt $vl [third [lindex $cgidata 1]]}
                   NEWOPT   {do_newOpt $vl}
                   DELOPT   {do_delOpt $vl}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

    LoadOptions


}   ;# end of if {$started == 0}




