
#    Note:  This is loaded into the namespace  PGRIS

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable RDOList { -1 0 0 0 0 0 0 0 0 0 0 1 } ;# 1 to 10 signify the enable bits for the board readout with 11:SYNC always enabled
    variable JS ""

    variable DCard 1

    
    variable ModuleMenu
    variable FEE64 [first $ModuleMenu]

    variable allmodules 0
    for { set i 1 } { $i <= 5 } { incr i } {
	variable Board$i 0 ; # not selected for readout 
	variable BoardColour$i "red" ; # hopefully the colour for an unselected board
    }

   proc  show_variables {} {
       variable allmodules
	variable RDOList
       for { set i 1 } { $i <= 5 } { incr i } { 
		variable Board$i 
		InsertLog "Board $i is [ set Board$i ] "
	}
	InsertLog "RDOList is $RDOList"
   }
   proc BoardToggle { i } { ; # toggle the state and colour of the select buttons for the boards to be used for readout
	variable Board$i
	variable BoardColour$i
	variable RDOList

	if { [ set Board$i ] == 0 } {
		set Board$i 1
		set BoardColour$i "green"
		set RDOList [ lreplace $RDOList $i $i 1 ] ;# enable the ASIC for readout
		set j [ expr $i + 5 ]
		set RDOList [lreplace $RDOList $j $j 1 ]; # enable the corresponding ADC for readout
	} else {
		set Board$i 0
		set BoardColour$i "red"
		set RDOList [lreplace $RDOList $i $i 0 ]; # disable the ASIC for readout
		set j [ expr $i + 5 ]
		set RDOList [lreplace $RDOList $j $j 0 ]; # disable the corresponding ADC for readout
	}
   }
   proc RunTest {i} {

       set rc [catch {source [file join Tests $i.tcl]} m]
       InsertLog "Test $i returned rc=$rc and message\n $m"
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   BOARD     {BoardToggle $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   EXPERT   {$vl [third [lindex $cgidata 1]]}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
     }

}   ;# end of if {$started == 0}




