
#    Note:  This is loaded into the namespace  TS

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable allmodules 0

    for {set i 0} {$i <= 13} {incr i} {variable Opt$i 0}


   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::PGRIS::FEE64"
       InsertLog "all modules = $allmodules"
   }

   proc do_redisplay {} {


     foreach i {0 1 4 5 } {
        variable Opt$i
        set Opt$i [ReadPGRISRegister [expr 0x20000 + 0x40 + $i]]
     }
   }

   proc do_setOpt {i vl} {
      variable allmodules

      set BAK $::PGRIS::FEE64   ;#   save

      foreach fee64 $::PGRIS::ModuleMenu {
          if {$allmodules == 0 && $fee64 != $::PGRIS::FEE64} continue

          set ::PGRIS::FEE64 $fee64
          WritePGRISRegister [expr 0x20000 + 0x40 + $i] $vl
      }

      set ::PGRIS::FEE64 $BAK   ;#   restore
   }

   proc ResetTS {} {

      set BAK $::PGRIS::FEE64

      foreach fee64 $::PGRIS::ModuleMenu {

            set ::PGRIS::FEE64 $fee64
        set control [ReadPGRISRegister [expr 0x20000 + 0x40]]
	set reset [ expr $control + 2 ]
        WritePGRISRegister [expr 0x20000 + 0x40] $reset
        WritePGRISRegister [expr 0x20000 + 0x40] $control

      }

      set ::PGRIS::FEE64 $BAK
  }

 


   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::PGRIS::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPTS     {do_setOpt [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




