
#    Note:  This is loaded into the namespace  DIAG

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
    variable LogFlag

   if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

}

if {$started == 0} {
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    set InterfaceList [list \
         "undefined"  \
         "bcm2835_gpio" \
         "bcm2835_spi" \
         "bcm2835_i2c" \
    ]

    set GPIOCmds1 [list \
         "undefined"  \
         "Enable Asynchronous Falling Edge Detect"  \
         "Enable Asynchronous Rising Edge Detect"  \
         "Set GPIO pin to LOW"  \
         "Disable Asynchronous Falling Edge Detect"  \
         "Disable Asynchronous Rising Edge Detect"  \
         "Disable Falling Edge Detect"  \
         "Disable High Detect"  \
         "Disable Low Detect"  \
         "Disable Rising Edge Detect" \
         "Event Detect Status" \
         "Enable Falling Edge Detect"  \
         "Enable High Detect"  \
         "Enable Low Detect"  \
         "Read level"  \
         "Enable Rising Edge Detect" \
         "Set Output to HIGH"  \
         "Clear Event Detect Status" \
    ]

    set GPIOcmds1 [list \
         "undefined"  \
         "bcm2835_gpio_afen"  \
         "bcm2835_gpio_aren"  \
         "bcm2835_gpio_clr"  \
         "bcm2835_gpio_clr_aren"  \
         "bcm2835_gpio_clr_aren"  \
         "bcm2835_gpio_clr_fen"  \
         "bcm2835_gpio_clr_hen"  \
         "bcm2835_gpio_clr_low"  \
         "bcm2835_gpio_clr_ren"  \
         "bcm2835_gpio_eds" \
         "bcm2835_gpio_fen" \
         "bcm2835_gpio_hen" \
         "bcm2835_gpio_len" \
         "bcm2835_gpio_lev" \
         "bcm2835_gpio_ren" \
         "bcm2835_gpio_set" \
         "bcm2835_gpio_set" \
         "bcm2835_gpio_set_eds" \
    ]

    set GPIOCmds2 [list \
         "undefined"  \
         "Set GPIO pins defined by mask to LOW"  \
         "Set GPIO pins defined by mask to HIGH"  \
    ]

    set GPIOcmds2 [list \
         "undefined"  \
         "bcm2835_gpio_clr_multi"  \
         "bcm2835_gpio_set_multi"  \
    ]

    set GPIOCmds3 [list \
         "undefined"  \
         "Set output state of GPIO pin"  \
    ]

    set GPIOcmds3 [list \
         "undefined"  \
         "bcm2835_gpio_write"  \
    ]

    set GPIOPins [list \
         "undefined"  \
         GPIO_P1_03 \
         GPIO_P1_05 \
         GPIO_P1_07 \
         GPIO_P1_08 \
         GPIO_P1_10 \
         GPIO_P1_11 \
         GPIO_P1_12 \
    ]

    set GPIOpins [list \
         -1 \
         0 \
         1 \
         4 \
         14 \
         15 \
         17 \
         18 \
    ]


    variable Interface "undefined"
    variable CurrentInterface "undefined"

    variable CurrentCmd1 "undefined"
    variable Currentcmd1 "undefined"
    variable CurrentPin1 -1
    variable Currentpin1 -1

    variable CurrentCmd2 "undefined"
    variable Currentcmd2 "undefined"
    variable CurrentMask2 0

    variable CurrentCmd3 "undefined"
    variable Currentcmd3 "undefined"
    variable CurrentPin3 -1
    variable Currentpin3 -1
    variable CurrentState3 "LOW"
    variable Currentstate3 0

    variable CurrentCmd9 "undefined"
    variable Currentcmd9 "undefined"
    variable scriptlist {undefined}
    variable scriptname [first $scriptlist]
    variable ScriptsDir "Scripts"


    proc  show_variables {} {
        variable CurrentInterface
        variable CurrentCmd1
        variable Currentcmd1
        variable CurrentPin1
        variable Currentpin1
        variable CurrentCmd2
        variable Currentcmd2
        variable CurrentMask2
        variable CurrentCmd3
        variable Currentcmd3
        variable CurrentState3
        variable Currentstate3

        InsertLog "CurrentInterface = $CurrentInterface"
        InsertLog "CurrentCmd1 = $CurrentCmd1"
        InsertLog "Currentcmd1 = $Currentcmd1"
        InsertLog "CurrentPin1 = $CurrentPin1"
        InsertLog "Currentpin1 = $Currentpin1"
        InsertLog "CurrentCmd2 = $CurrentCmd2"
        InsertLog "Currentcmd2 = $Currentcmd2"
        InsertLog "CurrentMask2 = $CurrentMask2"
        InsertLog "CurrentCmd3 = $CurrentCmd3"
        InsertLog "Currentcmd3 = $Currentcmd3"
        InsertLog "CurrentState3 = $CurrentState3"
        InsertLog "Currentstate3 = $Currentstate3"
    }

   proc scripts {} {
       variable ScriptsDir
       variable scriptlist
       variable scriptname

        set z [catch {file isdirectory $ScriptsDir} m]
        if {$z != 0 || $m == 0} {
            Alert "Unable to access $ScriptsDir or $ScriptsDir is not a directory"
            return
        }

        set arg "-name \"*tcl\""
        set z [catch {eval exec find $ScriptsDir $arg} m]

        if {$z != 0} {
            Alert "Unable to obtain Scripts files: $m"
            return
        }

        set scriptlist {undefined}
        foreach item $m {
            if {[string length $item] == 0} {continue}
            lappend scriptlist $item
        }

        set scriptname [first $scriptlist]
   }

   proc do_gpioPin1 {vl} {
      variable CurrentPin1 
      variable Currentpin1
      variable GPIOPins
      variable GPIOpins

      set CurrentPin1 $vl
      set Currentpin1 [lindex $GPIOpins [lsearch $GPIOPins $vl]]
   }

   proc do_gpioPin3 {vl} {
      variable CurrentPin3
      variable Currentpin3
      variable GPIOPins
      variable GPIOpins

      set CurrentPin3 $vl
      set Currentpin3 [lindex $GPIOpins [lsearch $GPIOPins $vl]]
   }

   proc do_gpioCmd1 {vl} {
      variable CurrentCmd1
      variable Currentcmd1
      variable GPIOCmds1 
      variable GPIOcmds1

      set CurrentCmd1 $vl
      set Currentcmd1 [lindex $GPIOcmds1 [lsearch $GPIOCmds1 $vl]]
   }

   proc do_gpioCmd2 {vl} {
      variable CurrentCmd2
      variable Currentcmd2
      variable GPIOCmds2
      variable GPIOcmds2

      set CurrentCmd2 $vl
      set Currentcmd2 [lindex $GPIOcmds2 [lsearch $GPIOCmds2 $vl]]
   }

   proc do_gpioCmd3 {vl} {
      variable CurrentCmd3
      variable Currentcmd3
      variable GPIOCmds3
      variable GPIOcmds3

      set CurrentCmd3 $vl
      set Currentcmd3 [lindex $GPIOcmds3 [lsearch $GPIOCmds3 $vl]]
   }

   proc do_gpioMask2 {vl} {
      variable CurrentMask2

      set CurrentMask2 $vl
   }

   proc do_gpioState3 {vl} {
      variable CurrentState3
      variable Currentstate3

      set CurrentState3 $vl
      switch $CurrentState3 {
        HIGH {set Currentstate3 1}
        LOW  {set Currentstate3 0}
      }
   }

   proc do_gpioCmd9 {vl} {
      variable CurrentCmd9
      variable scriptname

      set CurrentCmd9 $vl
      set scriptname $vl
   }

   proc do_spiCmd9 {vl} {
      variable CurrentCmd9
      variable scriptname

      set CurrentCmd9 $vl
      set scriptname $vl
   }

   proc do_gpioEXEC1 {} {
      variable Currentcmd1
      variable Currentpin1 

	set z [catch {bcm2835_gpio_init} rc]
        InsertLog "bcm2835_gpio_init returns $z $rc"
        if {$rc != 1} {
           InsertLog "GPIO open returned $rc"
           return;
        }

        set z [catch {$Currentcmd1 -p $Currentpin1} rc]
        InsertLog "$Currentcmd1 returns $z $rc"

	set z [catch {bcm2835_gpio_close} rc]
        InsertLog "bcm2835_gpio_close returns $z $rc"
   }

   proc do_gpioEXEC2 {} {
      variable Currentcmd2
      variable CurrentMask2

	set z [catch {bcm2835_gpio_init} rc]
        InsertLog "bcm2835_gpio_init returns $z $rc"
        if {$rc != 1} {
           InsertLog "GPIO open returned $rc"
           return;
        }

        set z [catch {$Currentcmd2 -m $CurrentMask2} rc]
        InsertLog "$Currentcmd2 returns $z $rc"

	set z [catch {bcm2835_gpio_close} rc]
        InsertLog "bcm2835_gpio_close returns $z $rc"
   }

   proc do_gpioEXEC3 {} {
      variable Currentcmd3
      variable Currentpin3
      variable Currentstate3

	set z [catch {bcm2835_gpio_init} rc]
        InsertLog "bcm2835_gpio_init returns $z $rc"
        if {$rc != 1} {
           InsertLog "GPIO open returned $rc"
           return;
        }

        set z [catch {$Currentcmd3 -p $Currentpin3 -m $Currentstate3} rc]
        InsertLog "$Currentcmd3 returns $z $rc"

	set z [catch {bcm2835_gpio_close} rc]
        InsertLog "bcm2835_gpio_close returns $z $rc"
   }


   proc do_gpioEXEC9 {} {
      variable CurrentCmd9

	set z [catch {bcm2835_gpio_init} rc]
        InsertLog "bcm2835_gpio_init returns $z $rc"
        if {$rc != 1} {
           InsertLog "GPIO open returned $rc"
           return;
        }

        set z [catch {source $CurrentCmd9} rc]
        if {$z != 0} {
           InsertLog "Script $CurrentCmd9 returns $rc"
        }

	set z [catch {bcm2835_gpio_close} rc]
        InsertLog "bcm2835_gpio_close returns $z $rc"
   }

   proc do_spiEXEC9 {} {
      variable CurrentCmd9

	set z [catch {bcm2835_spi_init} rc]
        InsertLog "bcm2835_spi_init returns $z $rc"
        if {$rc != 1} {
           InsertLog "SPI open returned $rc"
           return;
        }

        set z [catch {source $CurrentCmd9} rc]
        if {$z != 0} {
           InsertLog "Script $CurrentCmd9 returns $rc"
        }

	set z [catch {bcm2835_spi_close} rc]
        InsertLog "bcm2835_spi_close returns $z $rc"
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag
       variable LogFlag
       variable CurrentInterface

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgDiagnostics.tmlidata"
       } else {
          if {[lindex $cgidata 0] != "Widget"} then {
             InsertLog "Invalid CGI data: $cgidata"
          } else {

              set w [first [lindex $cgidata 1]]
              set vl [lrange [lindex $cgidata 1] 1 end]

            switch -glob $w {

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                INTERFACE {set CurrentInterface $vl}
                gpioEXEC1  {do_gpioEXEC1}
                gpioEXEC2  {do_gpioEXEC2}
                gpioEXEC3  {do_gpioEXEC3}
                gpioEXEC9  {do_gpioEXEC9}
                spiEXEC9  {do_spiEXEC9}
                gpioCmd1  {do_gpioCmd1 $vl}
                gpioCmd2  {do_gpioCmd2 $vl}
                gpioCmd3  {do_gpioCmd3 $vl}
                gpioMask2  {do_gpioMask2 $vl}
                gpioState3  {do_gpioState3 $vl}
                gpioCmd9  {do_gpioCmd9 $vl}
                spiCmd9  {do_spiCmd9 $vl}
                gpioPin1  {do_gpioPin1 $vl}
                gpioPin3  {do_gpioPin3 $vl}
 
                MainLog {}
                undefined {}
                default {InsertLog "unexpected CGI data:  $cgidata"}
            }
         }
      }
   }

   scripts

}   ;# end of if {$started == 0} 

