
#    Note:  This is loaded into the namespace  EASIC

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    
    variable HelpTopic "R3B"

    variable PAGEList {- 0 1 2 3}
    variable PAGE [first $PAGEList]

    variable SIDE 0
    catch {set SIDE [set ::R3B::[set ::R3B::R3B4K].SIDE]}

    variable ASIC 0
    catch {set ASIC [first [set ::R3B::[set ::R3B::R3B4K].ASICList$SIDE]]}

    variable allmodules 0
    variable allasics 0
    variable allsides 0
    variable allcals 0
    variable allpowers 0

    variable filelist {undefined}
    variable filename [first $filelist]
    
    for {set i 0} {$i <= 9} {incr i} {
        variable Reg.Value$i 0
        variable Reg.Offset$i $i
    }

    for {set i 10} {$i <= 21} {incr i} {
        variable Reg.Value$i 0
        variable Reg.Offset$i $i
    }

    for {set i 64} {$i <= 95} {incr i} {
        variable Reg.Value$i 0
        variable Reg.Offset$i $i
    }

    for {set i 128} {$i <= 255} {incr i} {   ;#   page n
        variable Reg.Value$i 0
        variable Reg.Offset$i $i
    }
    
   proc do_help {} {
      variable HelpTopic 

        set Txtfile [file join $HelpTopic.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Sorry unable to access $Txtfile\nInformation coming very soon!!\n"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc  show_variables {} {
       variable allmodules
       variable allasics
       variable allpowers
       variable allcals
       variable HelpTopic
       
       variable PAGE
       variable ASIC
       variable SIDE
       
       variable filelist
       variable filename
       
       InsertLog "R3B4K = $::R3B::R3B4K; PAGE = $PAGE; ASIC = $ASIC; SIDE=$SIDE"
       InsertLog "all modules = $allmodules; all asics = $allasics; all cals = $allcals; all powers = $allpowers"
       InsertLog "Help = $HelpTopic"

    for {set i 0} {$i <= 21} {incr i} {
        variable Reg.Value$i
        InsertLog "Reg.Value$i = [set Reg.Value$i]"
    }
       
       InsertLog "scripts = $filelist"
       
   }
    
    proc get_scripts {} {
        variable filelist
        variable filename
        global tcl_platform
        
        if {$tcl_platform(platform) == "windows"} {set filename "undefined"; return}

        set arg "-name \"*tcl\""
        set z [catch {eval exec find Scripts $arg} m]

        if {$z != 0} {
            InsertLog "Unable to obtain script files: $m"
            return
        }

        set filelist {}
        foreach item $m {
            if {[string length $item] == 0} {continue}
            lappend filelist $item
        }

        if {[llength $filelist] == 0} {set filename "undefined"} else {set filename [first $filelist]}

   }

   proc do_redisplay {} {
     variable SIDE
     variable PAGE
     variable ASIC

     if {$PAGE == "-"} {

        for {set i 0} {$i <= 9} {incr i} {
           variable Reg.Value$i
           set Reg.Value$i [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]]
        }

        for {set i 10} {$i <= 21} {incr i} {
           variable Reg.Value$i
           set Reg.Value$i [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]]
# InsertLog "Reg.Value$i =  [set Reg.Value$i] "
        }

        for {set i 64} {$i <= 95} {incr i} {
           variable Reg.Value$i
           set Reg.Value$i [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]]
       }

     } else {

	 WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + ($PAGE << 8) + 0]  [expr 1 << $PAGE]

        for {set i 128} {$i <= 255} {incr i} {
           variable Reg.Value$i
           set Reg.Value$i [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + ($PAGE << 8) + $i]]
        }
     }
   }

   proc do_setReg {i vl} {
      variable PAGE
      variable SIDE
      variable ASIC
      variable allmodules
      variable allasics
      variable allsides
      variable allcals
      variable allpowers

      set BAK $::R3B::R3B4K
      set ABAK $ASIC
      set SBAK $SIDE
     
      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

     foreach SIDE $::R3B::SIDEList {
        if {$allsides == 0 && $SIDE != $SBAK} continue
     
     foreach ASIC [set ::R3B::ASICList$SIDE] {
        if {$allasics == 0 && $ASIC != $ABAK} continue

          if {$PAGE == "-"} {
                 set done 0
                 if {$i >= 64 && $i < 80 && $allcals == 1} {
                     for {set j 64} {$j < 80} {incr j} {
                         WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $j] $vl
                         variable Reg.Value$j; set Reg.Value$j $vl
                     }
                     set done 1
                 }
                 if {$i >= 80 && $i < 96 && $allpowers == 1} {
                     for {set j 80} {$j < 96} {incr j} {
                         WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $j] $vl
                         variable Reg.Value$j; set Reg.Value$j $vl
                     }
                     set done 1
                 }
                 if {$done == 0} {
                     WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] $vl
                     variable Reg.Value$i; set Reg.Value$i $vl
                 }
          }  else {
	      WriteR3BASICRegister  [expr ($SIDE << 18) + ($ASIC << 10) + ($PAGE << 8) + 0] [expr 1 << $PAGE]
              variable Reg.Value0; set Reg.Value0 [expr 1 << $PAGE]
              WriteR3BASICRegister  [expr ($SIDE << 18) + ($ASIC << 10) + ($PAGE << 8) + $i] $vl
              variable Reg.Value$i; set Reg.Value$i $vl
          }
      }
      }

     }

      set selectmodule $BAK

      set ASIC $ABAK
      set SIDE $SBAK

      if {$allasics != 0} {do_redisplay}
   }

   proc do_CallAll {vl} {
      variable ASIC
      variable SIDE
      variable allmodules
      variable allasics
      variable allsides

      set BAK $::R3B::R3B4K
      set ABAK $ASIC
      set SBAK $SIDE

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          foreach SIDE $::R3B::SIDEList {
              if {$allsides == 0 && $SIDE != $SBAK} continue

          foreach ASIC [set ::R3B::ASICList$SIDE] {
              if {$allasics == 0 && $ASIC != $ABAK} continue

              for {set i 64} {$i <= 79} {incr i} {
                 WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] $vl
              }
          }
          }

      }

      selectmodule $BAK

      set ASIC $ABAK
      set SIDE $SBAK
   }

   proc do_PowerAll {vl} {
      variable ASIC
      variable SIDE
      variable allmodules
      variable allasics
      variable allsides

      set BAK $::R3B::R3B4K
      set ABAK $ASIC
      set SBAK $SIDE

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          foreach SIDE $::R3B::SIDEList {
              if {$allsides == 0 && $SIDE != $SBAK} continue

          foreach ASIC [set ::R3B::ASICList$SIDE] {
              if {$allasics == 0 && $ASIC != $ABAK} continue

              for {set i 80} {$i <= 95} {incr i} {
                 WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] $vl
              }
          }
          }
      }

      selectmodule $BAK

      set ASIC $ABAK
      set SIDE $SBAK
   }


   proc do_SetCalAll {} {do_CallAll 0xff; do_redisplay}

   proc do_UnSetCalAll {} {do_CallAll 0x00; do_redisplay}

   proc do_SetPowerDnAll {} {do_PowerAll 0xff; do_redisplay}

   proc do_UnSetPowerDnAll {} {do_PowerAll 0x00; do_redisplay}


   proc do_expert {cmd} {
      variable cgidata
      variable allmodules

      set BAK $::R3B::R3B4K

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          selectmodule $R3B4K

          switch $cmd {
              do_Initialise  {source [file join Scripts Initialise.tcl]}
              default {$cmd}
          }

      }

      selectmodule $BAK
   }

   proc selectmodule {vl} {
      variable ASIC
      variable SIDE

       set ::R3B::R3B4K $vl

          set ::R3B::SIDEList [set ::R3B::[set ::R3B::R3B4K].SIDEList]
          set ::R3B::SIDE [first $::R3B::SIDEList]
          set ::R3B::ASICList0 [set ::R3B::[set ::R3B::R3B4K].ASICList0]
          set ::R3B::ASICList1 [set ::R3B::[set ::R3B::R3B4K].ASICList1]

       set SIDE [first $::R3B::SIDEList]
       set ASIC [first [set ::R3B::ASICList$SIDE]]

  }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable HelpTopic

      variable allasics
      variable allcals
      variable allpowers

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {get_scripts; do_redisplay}
                   VARIABLES {show_variables}
                   
                   HELP     {
                       switch $vl {
                          0  {set HelpTopic "Hardware"}
                          1  {set HelpTopic "Select"}
                          2  {set HelpTopic "EASIC"}
                          3  {set HelpTopic "Screens"}
                          4  {set HelpTopic "Offsets"}
                          5  {set HelpTopic "Introduction"}
                          6  {set HelpTopic "Calibration"}
                          7  {set HelpTopic "ASIC"}
                          default {set HelpTopic "R3B"}
                       }
                       do_help
                   }

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {selectmodule $vl; do_redisplay}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}
                   ALLASICS   {variable allasics; set allasics [expr ($allasics + 1) & 1]}
                   ALLSIDES   {variable allsides; set allsides [expr ($allsides + 1) & 1]}
                   ALLCALS    {variable allcals; set allcals [expr ($allcals + 1) & 1]}
                   ALLPOWERS  {variable allpowers; set allpowers [expr ($allpowers + 1) & 1]}

                   PAGE     {variable PAGE; set PAGE $vl; do_redisplay}
                   ASIC     {variable ASIC; set ASIC $vl; do_redisplay}
                   SIDE     {variable SIDE; set SIDE $vl; do_redisplay}
                   SCRIPT   {variable filename; set filename $vl}
                   RUNSCRIPT {variable filename; source $filename}

                   REG     {do_setReg [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]; set allasics 0}
                   EXPERT   {do_expert $vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
       #        do_redisplay
     }

    #     do_redisplay
     get_scripts

}   ;# end of if {$started == 0}




