
#    Note:  This is loaded into the namespace  ASIC

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {
    
    variable JS ""
    variable LogFlag
    
    if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}
    
    do_click
}


if {$started == 0} {           ;#  first time load code and define local variables
    set started 1
    
    proc do_redisplay {} {;}
    
    proc do_FillFile {} {
	
	# Set file name
	set file_name  /MIDAS/SpecData/R3B/TestData/ 
	append file_name [clock format [clock seconds] -format "%Y-%m-%d-"]
	append file_name scan.txt
	
	# Create file and set permissions.
	set flag_open [catch {open $file_name w} file_input]
	set flag_perm [catch {file attributes $file_name -permissions rwxrwxrwx} ]
	
	if { $flag_open != 0 } { InsertLog "Cannot open $file_name." }
	if { $flag_perm != 0 } { InsertLog "Error setting permission of $file_name." }
	# Get data and fill file.
	for {set itr_1 0} {$itr_1 < 2} {incr itr_1} {
	    
	    variable data 0
	    unset data
	    for {set itr_2 0} {$itr_2 < 128} {incr itr_2} {
		append data [expr $itr_2 + $itr_1] " ";
	    }
	    
	    puts $file_input $data
	}
	
	close $file_input
    }
    
    proc do_AnalyseSpectra {} { 
	
	set SpecNames [SpectrumNames]
	# SpectrumNames is a function if Html/RunControl/sys.tcl
	# I do not understand how it can called here.
	# In fact I do not have any include of this file.
	
	#set itr [lindex $SpecNames 2178]
	foreach itr $SpecNames {
	    #each entry has length 2.
	    
	    if {[lindex $itr 0]!=1} { continue;}
	    
	    set SpecName [lindex $itr 1]
	    if { [string equal $SpecName "E.17.0"] } {
		
		set SpecDetails [SpectrumDetails $SpecName]
		# SpecDetails has lenght 6.
		# The third element is the range : [0, x-max].
		set range [lindex $SpecDetails 2]
		set data [SpectrumRead1D $SpecName 0 $range]
		# InsertLog "[llength $data]"
		# InsertLog "$data"
		
		set total_entries 0
		set mean 0
		for {set itr_data 0} {$itr_data < [llength $data]} {incr itr_data} {
		    set mean [expr $mean + ($itr_data * [lindex $data $itr_data]) ]
		    set total_entries [expr $total_entries + [lindex $data $itr_data]]
		}
		set mean [expr $mean / $total_entries]
		InsertLog "$mean"
	    }
	    
	}
    }
    
    proc  do_click {}  {
	variable cgidata
	variable started
	variable LogFlag
	variable ShowLogFlag

	set cgidata [ncgi::nvlist]
	
	if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}
	
	if {[llength $cgidata] == 0} then {return}
	
	if {[llength $cgidata] < 2} then {
	    InsertLog "CGI data is too short: $cgidata"
	} else {
	    if {[lindex $cgidata 0] != "Widget"} then {
		InsertLog "Invalid CGI data: $cgidata"
	    } else {
		
		set w [first [lindex $cgidata 1]]
		set vl [second [lindex $cgidata 1]]
		set vl2 [third [lindex $cgidata 1]]
		set vl3 [fourth [lindex $cgidata 1]]

		switch -glob $w {
		    
		    RESET { set started 0}
		    TEST1 {
			InsertLog "GO!";
			# do_inquiredevices
			do_go
			#set z [catch {::namespace inscope ::urn:TapeServer InquireAvailableDevices} msg]
			# set z [catch {::namespace inscope ::urn:TapeServer do_allocatedevice} msg]
			# InsertLog "$z"
			# do_openfile
		    }
		    TEST2 {
			InsertLog "STOP!"
			# set z [catch {::namespace inscope ::urn:TapeServer do_deallocatedevice} msg]
		    }
		    TEST3 { do_FillFile }
		    TEST4 { do_AnalyseSpectra }
		    
		    default {InsertLog "unexpected CGI data:  $cgidata"}
		}
	    }
        }
	do_redisplay
    }
    
}   ;# end of if {$started == 0}


