
# Check the status of the DAQ: 
# 0) Stop state.
# 1) Go state.

proc do_getstate {} {
    global errorCode errorInfo
    global DataAcquisitionControlServerHost
    global MIDAS_DataAcquisitionControlServer_Exists
    
    if {[info exists MIDAS_DataAcquisitionControlServer_Exists] && $MIDAS_DataAcquisitionControlServer_Exists == 1} {
	
	set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetState} m]
    } else {
	
	if {$DataAcquisitionControlServerHost != $::DataAcquisition::ACQSERVER} {
	    set DataAcquisitionControlServerHost  $::DataAcquisition::ACQSERVER
	    DataAcquisitionControlClient_Configure
	}
	set rc [catch {DataAcquisitionControlClient__GetState} m]
    }
    
    if {$rc != 0} {
	# InsertLog "DO GETSTATE returned with an error\n$m\n$errorCode\n$errorInfo"
	set rc -1
    } else {
	# InsertLog "DO GETSTATE returned $m"
	set rc [second $m]
    }
    
    return $rc
}
