
#    Note:  This is loaded into the namespace  TIMES

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable INFO ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""
    variable INFO ""

    variable allmodules 0

    variable SIDE 0
    catch {set SIDE [set ::R3B::[set ::R3B::R3B4K].SIDE]}

    variable ASIC 0
    catch {set ASIC [first [set ::R3B::[set ::R3B::R3B4K].ASICList$SIDE]]}

    for {set i 0} {$i <= 0} {incr i} {variable Opt1000.$i 0}


   proc  show_variables {} {
       variable allmodules 

       InsertLog "R3B4K = $::R3B::R3B4K"
       InsertLog "all modules = $allmodules"

       for {set i 0} {$i <= 0} {incr i} {variable Opt1000.$i; InsertLog "1000.$i = [set Opt1000.$i]"}
   }

   proc do_redisplay {} {

     for {set i 0} {$i <= 0} {incr i} {
        variable Opt1000.$i
        set Opt1000.$i [ReadR3BRegister [expr 0x400 + $i]]
     }
   }

   proc do_setOpt1000 {i vl} {
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          set ::R3B::R3B4K $R3B4K
          WriteR3BRegister [expr 0x400 + $i] $vl
      }

      set ::R3B::R3B4K $BAK   ;#  restore
   }

   proc do_expert {cmd} {

       switch $cmd {

          ResetTimeStamp {do_ResetTimeStamp}
          default {}
       }
   }

   proc do_ResetTimeStamp {} {
      variable SIDE
      variable ASIC
      variable allmodules

      set BAK $::R3B::R3B4K   ;#  save

      foreach R3B4K $::R3B::ModuleMenu {
          if {$allmodules == 0 && $R3B4K != $::R3B::R3B4K} continue

          set ::R3B::R3B4K $R3B4K

          set SBAK $SIDE
          foreach SIDE $::R3B::SIDEList {

          set ABAK $ASIC
          foreach ASIC [set ::R3B::ASICList$SIDE] {

              set i 1    ;#  REG1
              set REG1.$SIDE.$ASIC [ReadR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i]]
              set vl [expr ([set REG1.$SIDE.$ASIC] & 0xc0) + 0x20]  ;# VAL input resets the counter
              WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] $vl

          }
          set ASIC $ABAK
          }
          set SIDE $SBAK

          WriteR3BRegister 0x400 3   ;#  asic_val => ts_fpga_reset

          WriteR3BRegister 0x300 0

          set reg1 [ReadR3BRegister 0x301]
          WriteR3BRegister 0x301 10
          set reg2 [ReadR3BRegister 0x302]
          WriteR3BRegister 0x302 1
          set reg3 [ReadR3BRegister 0x303]
          WriteR3BRegister 0x303 1  ;# number of pulses

          WriteR3BRegister 0x300 4   ;#  reset to load values
          WriteR3BRegister 0x300 0

          WriteR3BRegister 0x300 3   ;#  start

          WriteR3BRegister 0x300 0   ;#  stop

          WriteR3BRegister 0x301 $reg1
          WriteR3BRegister 0x302 $reg2
          WriteR3BRegister 0x303 $reg3

          WriteR3BRegister 0x300 4   ;#  reset to load values
          WriteR3BRegister 0x300 0

          WriteR3BRegister 0x400 1   ;#  asic_val NOT => ts_fpga_reset

          set SBAK $SIDE
          foreach SIDE $::R3B::SIDEList {

          set ABAK $ASIC
          foreach ASIC [set ::R3B::ASICList$SIDE] {

              set i 1    ;#  REG1
              WriteR3BASICRegister [expr ($SIDE << 18) + ($ASIC << 10) + $i] [set REG1.$SIDE.$ASIC]

          }
          set ASIC $ABAK
          }
          set SIDE $SBAK
      }

#        InsertLog "Time Stamp Reset complete"

      set ::R3B::R3B4K $BAK   ;#  restore
   }

   proc selectmodule {vl} {
      variable ASIC
      variable SIDE

       set ::R3B::R3B4K $vl

          set ::R3B::SIDEList [set ::R3B::[set ::R3B::R3B4K].SIDEList]
          set ::R3B::SIDE [first $::R3B::SIDEList]
          set ::R3B::ASICList0 [set ::R3B::[set ::R3B::R3B4K].ASICList0]
          set ::R3B::ASICList1 [set ::R3B::[set ::R3B::R3B4K].ASICList1]

       set SIDE [first $::R3B::SIDEList]
       set ASIC [first [set ::R3B::ASICList$SIDE]]

  }
 
   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {selectmodule $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPTS1000     {do_setOpt1000 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {do_expert $vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

}   ;# end of if {$started == 0}




