

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable ModuleName sac
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable allmodules 0

    variable cbus 0
    variable mon2 0
    variable str  0
    variable mode 0
    variable mon0 0
    variable sm   0
    variable evcnt 0
    variable acq   0
    variable delr 0


     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#    register access procedures


   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

   proc show_variables {} {
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "ModuleMenu=$ModuleMenu; ModuleIndex=$ModuleIndex; "
        InsertLog "allmodules=$allmodules"
        InsertLog "Rmsg=$Rmsg"
        InsertLog "Wmsg=$Wmsg"
   }

    proc click-delr {vl} {WriteVMERegister DELR $vl}

    proc click-mon0 {vl} {WriteVMERegister MON0 $vl}

    proc click-mon2 {vl} {WriteVMERegister MON2 $vl}

    proc click-mode {vl} {WriteVMERegister Mode $vl}

    proc click-arm {} {WriteVMERegister ARM 0}

    proc click-acq {} {
        variable acq

        set acq [expr ($acq + 1) & 1]    ;# toggle bit
        WriteVMERegister Enable $acq
    }

    proc click-evclr {} {WriteVMERegister EVCLR 0}

    proc click-str {vl} {WriteVMERegister STR $vl}

    proc UpdateModule {} {

        variable cbus 
        variable mon2 
        variable str
        variable mode
        variable mon0
        variable sm
        variable evcnt
        variable acq
        variable delr

        set vl [ReadRegister DELR]
        set delr [expr $vl & 255]

        set vl [ReadRegister STR]
        set str [format "0x%x" [expr $vl & 255]]

        set acq [ReadRegister Enable]
        set evcnt [ReadRegister EVCNT]
        set sm [ReadRegister SM]
        set mon2 [ReadRegister MON2]
        set mon0 [ReadRegister MON0]
        set cbus [ReadRegister CBUS]
        set mode [ReadRegister Mode]
}

    proc do_Save {} {}       ;#  nothing to do
    proc do_Restore {} {}    ;#  nothing to do

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   OFFSET   {click-delr [lindex $w 2]}

                   ARM        {click-arm}
                   EVCLR      {click-evclr}
                   SMRST      {click-str 2; click-str 0}
                   ACQ        {click-acq}

                   MON0       {click-mon0 [lindex $w 1]}
                   MON2       {click-mon2 [lindex $w 1]}
                   MODE       {click-mode [lindex $w 1]}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
               UpdateModule
           }
       }
    }

}   ;# end of if {$started == 0}

