

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    variable offline 0

   variable SoftTrigRun 0

    variable Rmsg
    variable Wmsg

    variable ModuleName v1495dpp
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable V1495DPPRegisterMap {}
    lappend V1495DPPRegisterMap {Firmware Firmware_Rev}
    lappend V1495DPPRegisterMap {Scratch16 Scratch16}
    lappend V1495DPPRegisterMap {Arm Arm}
    lappend V1495DPPRegisterMap {Scratch32 Scratch32}

    variable DPPRegisterMap {}
    lappend DPPRegisterMap {Version Version}

    variable DPPCentrum {}
    lappend DPPCentrum {"Mode" Mode}
    lappend DPPCentrum {"TimeStamp [15:0]" Status2}
    lappend DPPCentrum {"TimeStamp [31:16]" Status3}
    lappend DPPCentrum {"TimeStamp [47:32]" Status4}
    lappend DPPCentrum {"EvNum [15:0]" Status5}
    lappend DPPCentrum {"EvNum [31:16]" Status6}
    lappend DPPCentrum {"CheckSum" Status7}
    lappend DPPCentrum {"Centrum Status" Status8}
    lappend DPPCentrum {"Centrum Config" Mis4}
    lappend DPPCentrum {"Inspection #1" Mis5}
    lappend DPPCentrum {"Inspection #2" Mis2}

    variable Config 0
    variable Config.B0 0
    variable Config.B2 0
    variable Config.B3 0
    variable Config.B4 0
    variable Config.B7 0
    variable Config.B8 0
    variable Config.B9 0

    variable SaveRestoreMenu {}



     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   proc do_ExpertHelp {} {

        set Txtfile [file join V1495DPP Expert.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc show_variables {} {
        variable ModuleName
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
             InsertLog "ModuleMenu=$ModuleMenu; ModuleName=$ModuleName; ModuleIndex=$ModuleIndex; "
             InsertLog "allmodules=$allmodules"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
             InsertLog "Firmware Version=[ReadVMERegister $ModuleName#$ModuleIndex.Version]"
   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

    proc UpdateModule {} {
        variable ModuleName
        variable ModuleIndex
       variable Config
       variable Config.B0
       variable Config.B2
       variable Config.B3
       variable Config.B4
       variable Config.B7
       variable Config.B8
       variable Config.B9

       set Config [ReadVMERegister $ModuleName#$ModuleIndex.Ctrl]

       set Config.B0 [expr $Config & 3]
       set Config.B2 [expr ($Config >> 2) & 1]
       set Config.B3 [expr ($Config >> 3) & 1]
       set Config.B4 [expr ($Config >> 4) & 1]
       set Config.B7 [expr ($Config >> 7) & 1]
       set Config.B8 [expr ($Config >> 8) & 1]
       set Config.B9 [expr ($Config >> 9) & 1]

   }

    proc click-SETTING {w vl} {
        variable ModuleName
        variable ModuleIndex
        variable allmodules

        if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}

        WriteVMERegisters $r.$w $vl
    }


    proc do_Save {which} {
        variable ModuleName
        variable ModuleIndex
        variable SaveRestoreMenu

       set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           DBSetValue Scratch16   [ReadVMERegister $ModuleName#$ModuleIndex.Scratch16]
           DBSetValue Scratch32   [ReadVMERegister $ModuleName#$ModuleIndex.Scratch32]

	foreach item $SaveRestoreMenu {
	    DBSetValue $item  [ReadVMERegister $ModuleName#$ModuleIndex.$item]
	}

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

   proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable SaveRestoreMenu

        set SAV1 $ModuleIndex

        set ModuleIndex $which

        InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex]"

       foreach item $SaveRestoreMenu {

	   WriteVMERegister $ModuleName#$ModuleIndex.$item [DBGetValue $item]
       }

        set ModuleIndex $SAV1
    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}

#        ::VMEConfig::WriteVMERegister HasBeenRestored 1

        InsertLog "Settings for All CAEN [set ModuleName] modules restored from DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

   proc do_SoftTrig {n} {
      variable SoftTrigRun
        variable ModuleName
        variable ModuleIndex

      switch $n {
        1     {WriteVMERegister $ModuleName#$ModuleIndex.Arm 0}
        0     {puts "V1495DPP finished SoftTrig run"; set SoftTrigRun 0}
        100   {set SoftTrigRun 1; after 100 ::V1495DPP::do_SoftTrig 99}
        99999 {puts "V1495DPP starting SoftTrig run"; set SoftTrigRun 1; after 100 ::V1495DPP::do_SoftTrig 99998}
        99998 {if {$::V1495DPP::SoftTrigRun ==0} return; WriteVMERegister $ModuleName#$ModuleIndex.Arm 0; after 100 ::V1495DPP::do_SoftTrig 99998}
        default  {if {$::V1495DPP::SoftTrigRun ==0} return; WriteVMERegister $ModuleName#$ModuleIndex.Arm 0; if {$n > 0} {after 100 ::V1495DPP::do_SoftTrig [expr $n-1]}}
      }
   }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag
       variable ModuleIndex
       variable ModuleName

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   EXPERT {
                      switch [lindex $w 1] {
                        Help      {do_ExpertHelp}
                        FirmwareUpdate {Alert "Start firmware update from VME Control page"}
                        SoftTrig  {do_SoftTrig [lindex $w 2]}
                        AcqStart  {source [file join V1495DPP AcqStart.tcl]}
                        AcqHalt   {source [file join V1495DPP AcqHalt.tcl]}
                        Scratch     {WriteVMERegister $ModuleName#$ModuleIndex.Scratch32 12345}
                        default     {WriteVMERegister $ModuleName#$ModuleIndex.[lindex $w 1] 1}
                      }
                   }
                   EXPERTHELP    {do_ExpertHelp}

                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE         {do_Save $ModuleIndex}
                   RESTORE      {do_Restore $ModuleIndex}

                   SETTING     {click-SETTING [lindex $w 1] [lindex $w 2]}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}

