

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable ModuleName v812
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable numchans 16

    variable allmodules 0
    variable allchans 0

    for {set i 0} {$i < $numchans} {incr i} {variable Enable$i 0}
    for {set i 0} {$i < $numchans} {incr i} {variable Threshold$i 0}

    variable width0 0
    variable width1 0
    variable dtime0 0
    variable dtime1 0
    variable mthres 0

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#    register access procedures


   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

   proc show_variables {} {
        variable ModuleName
        variable ModuleIndex
        variable ModuleMenu
        variable allmodules
        variable allchans
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

        InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag"
        InsertLog "ModuleMenu=$ModuleMenu; ModuleName=$ModuleName; ModuleIndex=$ModuleIndex; "
        InsertLog "allmodules=$allmodules; allchans=$allchans"
        InsertLog "Rmsg=$Rmsg"
        InsertLog "Wmsg=$Wmsg"
   }


    proc UpdateModule {} {}

    proc click-ID {} {
        variable ModuleName
        variable ModuleIndex

        foreach id {1 2 3} {
           set vl [ReadVMERegister $ModuleName#$ModuleIndex.ModID#$id]
           InsertLog "V812 Module Identifier Word $id = $vl"
        }
    }

    proc click-TEST {} {
        variable ModuleName
        variable ModuleIndex
        variable allmodules

        if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}

        set vl [WriteVMERegisters $r.Test 0]
    }

    proc click-OFFSET {w vl} {
        variable ModuleName
        variable ModuleIndex
        variable allmodules
        variable allchans
        variable width0 
        variable width1 
        variable dtime0 
        variable dtime1 
        variable mthres 
        variable numchans
        for {set i 0} {$i < $numchans} {incr i} {variable Threshold$i}

#InsertLog "click-OFFSET $w $vl"

        if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}
        if {$allchans == 0} then {set c $w} else {set c *}

       switch $w {

           16   {WriteVMERegisters $r.OutputWidthL $vl; set width0 $vl}
           17   {WriteVMERegisters $r.OutputWidthH $vl; set width1 $vl}
           18   {WriteVMERegisters $r.DeadTimeL $vl; set dtime0 $vl}
           19   {WriteVMERegisters $r.DeadTimeL $vl; set dtime1 $vl}
           20   {WriteVMERegisters $r.MajorityThreshold [expr ((($vl*50)-25)+2)/4]; set mthresh $vl}

           default   {
                 WriteVMERegisters $r.Threshold$c $vl; set Threshold$w $vl
                 for {set i 0} {$i < $numchans} {incr i} {
                    if {$allchans == 1} {set Threshold$i $vl}
                 }
           }

       }
    }

    proc click-ENABLE {w vl} {
        variable ModuleName
        variable ModuleIndex
        variable allmodules
        variable allchans
        variable numchans
        for {set i 0} {$i < $numchans} {incr i} {variable Enable$i}

#InsertLog "click-ENABLE $w $vl"

        if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}

         if {$w == 16} {set BAK $allchans; set allchans 1}

          for {set i 0} {$i < $numchans} {incr i} {
             if {$allchans == 0 && $w != $i} {continue}
                 switch $vl {
                   false  {WriteVMERegisters $r.Enable$i 0; set Enable$i 0}
                   true   {WriteVMERegisters $r.Enable$i 1; set Enable$i 1}
                 }
          }

         if {$w == 16} {set allchans $BAK} 
    }


    proc do_Save {} {}       ;#  nothing to do
    proc do_Restore {} {}    ;#  nothing to do

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}
                   ALLCHANS   {variable allchans; set allchans [expr ($allchans + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   ENABLE   {click-ENABLE [lindex $w 1] [lindex $w 2]}
                   OFFSET   {click-OFFSET [lindex $w 1] [lindex $w 2]}

                   TEST     {click-TEST}
                   ID       {click-ID}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
               UpdateModule
           }
       }
    }

}   ;# end of if {$started == 0}

