
#    RunControl specific for data acquisition for PULSER (demo for Raspberry PI)


namespace eval DataAcquisition {
     variable PROJECT; if {![info exists PROJECT]} {set PROJECT PULSER}
     variable ACQSERVERS; if {![info exists ACQSERVERS]} {set ACQSERVERS [list [exec uname -n]]}
     variable ACQSERVER; if {![info exists ACQSERVER]} {set ACQSERVER [first $ACQSERVERS]}
}

namespace eval $::DataAcquisition::PROJECT {
    variable DBRootName; if {![info exists DBRootName]} {set DBRootName [file join EXPERIMENTS $::DataAcquisition::PROJECT]}
    variable DBNodeBase; if {![info exists DBNodeBase]} {set DBNodeBase 2012}
    variable DBNodeName; if {![info exists DBNodeName]} {set DBNodeName [exec uname -n]}
}


puts "loading tcl/PULSERRunControl.tcl for namespace [namespace current]"

   set z [catch {package require RunControlServer} m]
   if {$z != 0} {puts "RunControl returned z=$z and $m"} else {puts "RunControl loaded"}

#    provides the following 

#   Appdo_Setup
#   Appdo_Stop
#   Appdo_Go
#   Appdo_Reset
#   Appdo_SetOption
#   Appdo_GetOption
#   Appdo_GetCounters
#   Appdo_GetRates
#   Appdo_GetState


   global env

     set f [file join $env(MIDASBASE) TclHttpd Html RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "PULSER RunControl returned z=$z and $m"} else {puts "PULSER RunControl loaded"}

     set f [file join $env(MIDASBASE) TclHttpd Html PULSER RunControl implementation.tcl]
     set env(ProjectRunControlImplementation) $f
     set z [catch {source $f} m]
     if {$z != 0} {puts "PULSER RunControl returned z=$z and $m"} else {puts "PULSER RunControl loaded"}

global MIDAS_PULSERRunControl_Exists
set MIDAS_PULSERRunControl_Exists 1

package provide PULSERRunControl 1.0
