
#   MIDAS  Httpd Service for the TargetWheel Server

package require MIDASDomainHandler    ;#  load default support procedures

global MIDAS_TargetWheel_Exists
set MIDAS_TargetWheel_Exists 1

global MIDAS_TargetWheelService_Verbose
set MIDAS_TargetWheelService_Verbose 1

global MIDAS_SOAPDomainHandler_Verbose
set MIDAS_SOAPDomainHandler_Verbose 0


upvar #0 TargetWheelService_Addr Addr
upvar #0 TargetWheelService_Port Port


# Use namespaces to isolate your methods
namespace eval urn:TargetWheelService {

    proc AccessServerVerbose {option} {
        global MIDAS_TargetWheelService_Verbose
        global MIDAS_RegisterAccessServer_Verbose
        global MIDAS_SOAPDomainHandler_Verbose

        set MIDAS_TargetWheelService_Verbose $option
        set MIDAS_RegisterAccessServer_Verbose $option
        set MIDAS_SOAPDomainHandler_Verbose $option

        return [rpcvar::rpcvar int 0]
    }

    proc Init {} {
        upvar #0 TargetWheelService_NumModule NumModule

        return [rpcvar::rpcvar int $NumModule]
    }

    proc WriteControl {Value} {
        do_WriteControl $Value
        return [rpcvar::rpcvar int 0]
    }

    proc ReadControl {} {
        set vl [do_ReadControl]
        return [rpcvar::rpcvar int $vl]
    }

    proc Status {} {
        set vl [do_Status]
        return [rpcvar::rpcvar int $vl]
    }

    proc Version {} {
        set vl [do_Version]
        return [rpcvar::rpcvar int $vl]
    }


    proc do_WriteControl {Value} {
        upvar #0 MIDAS_TargetWheelService_Verbose Verbose

        if {$Verbose} {puts "called method TargetWheelService::WriteControl"}
 
#    now start access 

        do_Connect

#    do action

#        TDRIAccess_WriteControl $Value

        return    ;# completed 
    }

    proc do_ReadControl {} {
        upvar #0 MIDAS_TargetWheelService_Verbose Verbose

        if {$Verbose} {puts "called method TargetWheelService::ReadControl"}

#    now start access

        do_Connect

#    do action

    set vl 555

#       set vl [TDRIAccess_ReadControl]

        return $vl   ;# completed 
    }

    proc do_Status {} {
        upvar #0 MIDAS_TargetWheelService_Verbose Verbose

        if {$Verbose} {puts "called method TargetWheelService::Status"}

#    now start access

        do_Connect

#    do action

   set vl 0

#       set vl [TDRIAccess_Status]

        return  $vl   ;# completed 
    }

    proc do_Version {} {
        upvar #0 MIDAS_TargetWheelService_Verbose Verbose

        if {$Verbose} {puts "called method TargetWheelService::Version"}

#    now start access

        do_Connect

#    do action

    set vl 1

 #      set vl [TDRIAccess_Version]

        return  $vl   ;# completed 
    }

proc do_Connect {} {
        upvar #0 MIDAS_TargetWheelService_Verbose Verbose

 #       upvar #0 TargetWheelService_Addr Addr
 #       upvar #0 TargetWheelService_Port Port

#            package require TDRIAccess

 #           TDRIAccess_Verbose $Verbose

 #           TDRIAccess_Configure -n $Addr($Module) -p $Port($Module)  

 #           TDRIAccess_Init
}


    # We have to publish the public methods...

     SOAP::export AccessServerVerbose
     SOAP::export Select
     SOAP::export Status
     SOAP::export WriteControl
     SOAP::export ReadControl
     SOAP::export Version

     
}   ;#  end of    namespace eval urn:TargetWheelService

# register this service with tclhttpd
set rc [SOAP::Domain::register  -prefix  /TargetWheelService -namespace urn:TargetWheelService -uri urn:TargetWheelService]

puts "$rc"


proc ::SOAP::Domain::MIDAS_SOAPDomainHandler_/TargetWheelService {optsname sock args} {   \
    ::SOAP::Domain::MIDAS_SOAPDomainHandler_/DefaultAccessServer $optsname $sock $args}



package provide TargetWheel 1.0
